 
/*{{{  Includes*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <dirent.h>
#include "config.h"

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>

#include "datei.xbm"
#include "dateio.xbm"
#include "dateibak.xbm"
#include "link.xbm"

/*}}}  */

/*{{{F config.h*/
/*:::F config.h*/
/*}}}  */

int CONFIG_XDESKTOP = 0;

int IconImageW[MAX_FILETYPES];
int IconImageH[MAX_FILETYPES];
XImage *IconImage[MAX_FILETYPES];
XImage *DateiImage;
XImage *DateiOImage;
XImage *DateiBAKImage;
XImage *LinkImage;
 
 
#include "xbmfx.c"
#include "setupa.xbh"
#include "setupa.xbc"

/*{{{F setupa.xbc*/
/*:::F setupa.xbc*/
/*}}}  */

 
/*{{{  DATA_SETUP SETUP = {*/
DATA_SETUP SETUP = {
  0,       /* NoDirt */
  0,       /* NoBack */
  0,       /* NoUnknown */
  1,       /* AskBeforeDelete */
  /*{{{  DirMenuLabel*/
   {
   " Directory", " ",     " Create",  "",         " tar czvf",
   "",           " Move", " Copy",    " Symlink", " Delete" ,
   " ",          " ",     " ",        " ",        " ",
   " ",          " ",     " ",        " ",        " ",
   },
  /*}}}  */
  /*{{{  DirMenuAction*/
  {
  "",
  "",
  "mkdir (qf'Please enter new directory name' '')",
  "",
  "tar czvf (tf).taz (tf)",
  "",
  "mv (tf) (qf'Please enter target name for' '(tf):')",
  "cp (tf) (qf'Please enter target name for' '(tf):') -r",
  "ln (tf) (qf'Please enter symlink target name' 'from (tf):') -s",
  "(if'Do you really want to delete directory tree' '(tf)?') rm (tf) -r",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  "",
  },
  /*}}}  */
  /*{{{  FileMenuLabel*/
  {
  " File",    " Info",    " Show" ,    " Edit Joe",  " Edit Ori",
  " Print",   " DVI->LJ", " Move",     " Copy",      " Symlink",
  " Delete" , " TeX" ,    " strip ^M", " PC ->\"a", "",
  "",           "",           "",            "",             "",
  },
  /*}}}  */
  /*{{{  FileMenuAction*/
  {
  "",
  "ls -l (tf) > /.xdesktop-buf",
  "(show)",
  "trm -exec \"joe (tf)\" &",
  "trm -exec \"origami (tf)\" &",
  "cp (tf) /dev/lp1 > /.xdesktop-buf &",
  "trm -exec \"dvilj2p (tf)\" > /.xdesktop-buf &",
  "mv (tf) (qf'Please enter new target name for' '(tf):')",
  "cp (tf) (qf'Please enter new target name for' '(tf):') > /.xdesktop-buf",
  "ln (lf) (qf'Please enter new symlink name for' '(tf):') -s ",
  "(if'Do you really want to delete file' '(tf) ?') rm (tf)",
  "xterm -exec execw \"latex (tf)\" &",
  "stripl (tf)",
  "umlaut (tf)",
  "",
  "",
  "",
  "",
  "",
  "",
  },
  /*}}}  */
  /*{{{  UserMenuLabel*/
  {
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  },
  /*}}}  */
  /*{{{  UserMenuAction*/
  {
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  },
  /*}}}  */
  /*{{{  StandardLabel*/
  {
  "",          "*.c",        "*.h",          "*.o",           "*.tex",
  "*.mta",     "*.xbm",      "*.lj",         "*.bak",         "Makefile",
  "*[Hh]elp*", "",           "Project",      ".Z",            ".bat",
  ".dvi",      ".mfx",       ".prj",         ".fig",          "build.mta"
  ".taz",      "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  },
  /*}}}  */
  /*{{{  StandardAction*/
  {
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  },
  /*}}}  */
  /*{{{  StandardIcon*/
  {
   "datei.xbm",    "dateic.xbm",   "dateih.xbm",    "dateio.xbm",   "dateitex.xbm",
   "dateimta.xbm", "dateixbm.xbm", "dateilj.xbm",   "dateibak.xbm", "dateiwrk.xbm",
   "dateiinf.xbm", "dateiexe.xbm", "dateiprj.xbm",  "dateiz.xbm",   "dateidos.xbm",
   "dateidvi.xbm", "dateimfx.xbm", "dateiproj.xbm", "dateifig.xbm", "dateixbld.xbm",
   "dateitaz.xbm", "",             "",              "",             "",
  
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              ""
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  "",          "",           "",             "",              "",
  },
  /*}}}  */
  /*{{{  StandardFCol*/
  {
   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,
   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,   1,  1,  1,  1,  1,
  },
  /*}}}  */
  /*{{{  StandardBCol*/
  {
  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,
  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,
  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,
  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,
  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,  15, 15, 15, 15, 15,
  },
  /*}}}  */
 
  ".",   /* CurDir */
  "*",   /* DirMask */
 
  /*{{{  ColorTexte*/
  {
  "black",
  "blue3",
  "green3",
  "cyan3",
  "red3",
  "magenta3",
  "sandybrown",
  "lightgray",
  "black",
  "lightblue1",
  "green1",
  "red1",
  "cyan1",
  "magenta1",
  "yellow",
  "white",
  
  "gold",
  "maroon",
  "tomato",
  "hotpink",
  
  "beige",
  "seagreen",
  "salmon",
  "purple",
  
  "dark khaki",
  "",
  "",
  "",
  
  "",
  "",
  "",
  ""
  },
  
  /*}}}  */
 
 
  1,    /* draw_icon */
  0,    /* bigsize */
  880,  /* winw */
  730,  /* winh */
  640,  /* maxy */
  {"Hendrikomander"},
  300,
  {" Left mouse key starts standard action (i.e. will delete backups and trash or start editor)."},
  {" Right mouse key displays submenu for actions (use <ESC> key to quit)."},
  {" <ESC> cancels any selection."},
  {" Use <Exit> Button (top right) to leave the program."},
  {" "}
 
  };
 
 
 
/*}}}  */


#define PckTLen 300
char PTS[PckTLen+1];
/*{{{  char *PackText(char *str){*/
char *PackText(char *str){
  short cc,ll;
  cc = 0;
  while((str[cc] == ' ') & (strlen(str) > cc)) {
    cc++;
    };
  ll = 0;
  while((ll< strlen((char *)str))&(ll<PckTLen)){
    PTS[ll] = str[cc+ll];
    ll++;
    };
  if (strlen(str) >= PckTLen) {
    PTS[PckTLen-1] = 0;
    }
  else {
    PTS[strlen(str)] = 0;
    };
  while((PTS[strlen(PTS)-1] == ' ') & (strlen(PTS) > 0)) {
    PTS[strlen((char *)PTS)-1] = 0;
    };
  return(PTS);
  };

/*}}}  */
/*{{{  int ExecCommandLine(char *cmd, char *name, char *lname, int xa, int ya){*/
int ExecCommandLine(char *cmd, char *name, char *lname, int xa, int ya){
  char sstr[400]; char astr[400];
  int donotclearscreen=0;
  sprintf(sstr,"%s",cmd);
 
  XbWSMs_SetClockCursor();
  while(strstr(sstr,"(show)") != NULL){
    strcpy(astr,strstr(sstr,"(show)")+6);
    strcpy(strstr(sstr,"(show)")," ");
    strcat(sstr,astr);
    ShowFile(lname);
    donotclearscreen=1;
    };
  while(strstr(sstr,"(tn)") != NULL){
    char nstr[100];
    char *pstr;
    strcpy(nstr,name);
    pstr=NULL;
    while (strchr(nstr,'.') != NULL){ /* find last . */
      strcpy((pstr=strchr(nstr,'.')),"\0");
      };
    if (pstr != NULL){
      strcpy(nstr,name);
      strcpy(pstr,"\0");
      };
    strcpy(astr,strstr(sstr,"(tn)")+4);
    strcpy(strstr(sstr,"(tn)"),nstr);
    strcat(sstr,astr);
    };
  while(strstr(sstr,"(tf)") != NULL){
    strcpy(astr,strstr(sstr,"(tf)")+4);
    strcpy(strstr(sstr,"(tf)"),name);
    strcat(sstr,astr);
    };
  while(strstr(sstr,"(lf)") != NULL){
    strcpy(astr,strstr(sstr,"(lf)")+4);
    strcpy(strstr(sstr,"(lf)"),SETUP.cur_dir);
    strcat(sstr,"/");
    strcat(sstr,name);
    strcat(sstr,astr);
    };
  while(strstr(sstr,"(if'") != NULL){
    char ta[100],tb[100];
    strcpy(astr,strstr(sstr,"(if'")+4);
    strcpy(ta,astr);
    strcpy(strstr(ta,"'"),"\0");
    strcpy(tb,strstr(astr,"' '")+3);
    strcpy(strstr(tb,"'"),"\0");
 
    if (SETUP.ASK_BEFORE_DELETE){
      if (GetUserAnswer(xa, ya, ta, tb, " Yes", " Cancel", " No")!=1){
        return(donotclearscreen);  /* 1: Do not redraw screen */
        };
      };
    strcpy(strstr(sstr,"(if'"),"");
    strcat(sstr,strstr(astr,")")+1);
    };
  while(strstr(sstr,"(qf'") != NULL){
    char ta[100],tb[100],query[100];
    strcpy(astr,strstr(sstr,"(qf'")+4);
    strcpy(ta,astr);
    strcpy(strstr(ta,"'"),"\0");
    strcpy(tb,strstr(astr,"' '")+3);
    strcpy(strstr(tb,"'"),"\0");
 
    strcpy(query,"");
    if (!GetUserRequest(xa, ya, ta, tb, query)){
      return(donotclearscreen);  /* 1: Do not redraw screen */
      };
    strcpy(strstr(sstr,"(qf'"),query);
    strcat(sstr,strstr(astr,")")+1);
    };

  if(strstr(sstr,"(LoadSetup)") != NULL){
    while(strstr(sstr,"(LoadSetup)") != NULL){
      strcpy(astr,strstr(sstr,"(LoadSetup)")+11);
      strcpy(strstr(sstr,"(LoadSetup)"),"\0");
      strcat(sstr,astr);
      };
    FreeImages();
    LoadSetup(sstr);
    LoadImages();
    XbWSMs_SetArrowCursor();
    return(0);
    };
  if(strstr(sstr,"(SaveSetup)") != NULL){
    while(strstr(sstr,"(SaveSetup)") != NULL){
      strcpy(astr,strstr(sstr,"(SaveSetup)")+11);
      strcpy(strstr(sstr,"(SaveSetup)"),"\0");
      strcat(sstr,astr);
      };
    SaveSetup(sstr);
    XbWSMs_SetArrowCursor();
    return(0);
    };
  if (strlen(PackText(sstr)) > 0){
    system(sstr);
    };
  XbWSMs_SetArrowCursor();
  return(donotclearscreen);  /* 1: Do not redraw screen */
  };
/*}}}  */
/*{{{  void LoadImages(void){*/
void LoadImages(void){
  int ii;
  for(ii=0;ii<100;ii++){
    unsigned char *pmap_data;
    XImage *image;
    int w,h,xh,yh;
    IconImage[ii] = NULL;
    IconImageW[ii] = 0;
    IconImageH[ii] = 0;
    if (XmuReadBitmapDataFromFile(
        SETUP.StandardIcon[ii],
        &w, &h,
        &pmap_data,
        &xh, &yh
        ) == BitmapSuccess){
      image = XCreateImage(
         XbWVSy_ConTxt.dpy,
         XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
         1,
         XYBitmap,
         0,
         pmap_data,
         w,
         h,
         8,
         0);
      IconImage[ii] = image;
      IconImageW[ii] = w;
      IconImageH[ii] = h;
      };
    };
  /*{{{  DateiImage = XCreateImage(*/
  DateiImage = XCreateImage(
    XbWVSy_ConTxt.dpy,
    XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
    1,
    XYBitmap,
    0,
    datei_bits,
    datei_width,
    datei_height,
    8,
    0);
  /*}}}  */
  /*{{{  DateiOImage = XCreateImage(*/
  DateiOImage = XCreateImage(
    XbWVSy_ConTxt.dpy,
    XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
    1,
    XYBitmap,
    0,
    dateio_bits,
    dateio_width,
    dateio_height,
    8,
    0);
  /*}}}  */
  /*{{{  DateiBAKImage = XCreateImage(*/
  DateiBAKImage = XCreateImage(
    XbWVSy_ConTxt.dpy,
    XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
    1,
    XYBitmap,
    0,
    dateibak_bits,
    dateibak_width,
    dateibak_height,
    8,
    0);
  /*}}}  */
  /*{{{  LinkImage = XCreateImage(*/
  LinkImage = XCreateImage(
    XbWVSy_ConTxt.dpy,
    XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
    1,
    XYBitmap,
    0,
    link_bits,
    link_width,
    link_height,
    8,
    0);
  /*}}}  */
  };
/*}}}  */
/*{{{  void FreeImages(void){*/
void FreeImages(void){
  int ii;
  for(ii=0;ii<100;ii++){
    if (IconImage[ii]!=NULL){
      XDestroyImage(IconImage[ii]);
      IconImage[ii] = NULL;
      };
    };
  };
/*}}}  */
/*{{{  void ClearImages(void){*/
void ClearImages(void){
  int ii;
  for(ii=0;ii<100;ii++){
    IconImage[ii] = NULL;
    };
  };
/*}}}  */
/*{{{  int GetFileType(char *name){*/
int GetFileType(char *name){
  int ii;
  /*{{{  if (name[strlen(name)-1] == '~'){*/
  if (name[strlen(name)-1] == '~'){
    return F_TYPE_BAK;
    };
  /*}}}  */
  /*{{{  if (name[strlen(name)-2] == '.'){*/
  if (name[strlen(name)-2] == '.'){
    /*{{{  switch (name[strlen(name)-1]){*/
    switch (name[strlen(name)-1]){
      case 'o': return F_TYPE_O;
      };
    /*}}}  */
    };
  /*}}}  */
  /*{{{  if (name[strlen(name)-4] == '.'){*/
  if (name[strlen(name)-4] == '.'){
    /*{{{  if (strcmp(".aux",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".aux",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_O);
      };
    /*}}}  */
    /*{{{  if (strcmp(".lof",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".lof",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_O);
      };
    /*}}}  */
    /*{{{  if (strcmp(".log",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".log",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_O);
      };
    /*}}}  */
    /*{{{  if (strcmp(".toc",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".toc",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_O);
      };
    /*}}}  */
    /*{{{  if (strcmp(".bak",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".bak",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_BAK);
      };
    /*}}}  */
    /*{{{  if (strcmp(".out",(char*)&name[strlen(name)-4]) == 0){*/
    if (strcmp(".out",(char*)&name[strlen(name)-4]) == 0){
      return(F_TYPE_O);
      };
    /*}}}  */
    };
  /*}}}  */
  /*{{{  if (strcmp(name,"core") == 0){*/
  if (strcmp(name,"core") == 0){
    return(F_TYPE_O);
    };
  /*}}}  */
  /*{{{  if (strcmp(name,"tt.t") == 0){*/
  if (strcmp(name,"tt.t") == 0){
    return(F_TYPE_O);
    };
  /*}}}  */
  /*{{{  if (strcmp(name,"ttt") == 0){*/
  if (strcmp(name,"ttt") == 0){
    return(F_TYPE_O);
    };
  /*}}}  */
  /*{{{  if (strncmp(name,"test",4) == 0){*/
  if (strncmp(name,"test",4) == 0){
    return(F_TYPE_O);
    };
  /*}}}  */
  /*{{{  if (strncmp(name,"DEAD",4) == 0){*/
  if (strncmp(name,"DEAD",4) == 0){
    return(F_TYPE_O);
    };
  /*}}}  */
  for (ii=0;ii<MAX_FILETYPES;ii++){
    if (wild_match(name,SETUP.StandardLabel[ii])){
      return(F_TYPE_STANDARD+ii);
      };
    };
  return(F_TYPE_UNKNOWN);
  };
/*}}}  */
/*{{{  int ShowFileIcon(char *name, char *lname){*/
int ShowFileIcon(char *name, char *lname){
  int fcol,bcol;
  char sstr[200];
  XImage *theimage;
  int type;
  strncpy(sstr,name,15);
  sstr[15] = 0;
 
  theimage = DateiImage;
  bcol = 7; fcol = 8;
  switch((type=GetFileType(name))){
    case F_TYPE_O:   theimage = DateiOImage;   fcol=8;  bcol= 7;  break;
    case F_TYPE_BAK: theimage = DateiBAKImage; fcol=8;  bcol=15;  break;
 
    default:
      if ((type >= F_TYPE_STANDARD)&(type < F_TYPE_STANDARD+MAX_FILETYPES)){
        if (IconImage[type-F_TYPE_STANDARD] != NULL){
          theimage = IconImage[type-F_TYPE_STANDARD];
          fcol=SETUP.StandardFCol[type-F_TYPE_STANDARD];
          bcol=SETUP.StandardBCol[type-F_TYPE_STANDARD];
          break;
          };
        };
 
    };
 
  /*{{{  XbWSGr_BCImageBox(*/
  XbWSGr_BCImageBox(
    ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-15,
    ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X-2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-2,
    sstr,
    bcol,
    fcol,
    fcol);
  /*}}}  */
  if (IsLink(SETUP.cur_dir,name)){
    /*{{{  XPutImage(*/
    if (SETUP.draw_icon){
      XPutImage(
        XbWVSy_ConTxt.dpy,
        XbWVSy_ConTxt.window,
        XbWVSy_ConTxt.gc,
        LinkImage,
        0,0,
        ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
        icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
        ICON_SIZE_X,
        ICON_SIZE_Y
        );
      };
    /*}}}  */
    };
  /*{{{  XPutImage(*/
  if (SETUP.draw_icon){
    XPutImage(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      theimage,
      0,0,
      ICON_FSTART_X+icon_x*ICON_SPACE_X+27,
      icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
      ICON_SIZE_X,
      ICON_SIZE_Y
      );
    };
  /*}}}  */
  };
/*}}}  */
/*{{{  int ShowClickedFileIcon(char *name, char *sname){*/
int ShowClickedFileIcon(char *name, char *sname){
  int fcol,bcol;
  char sstr[200];
  XImage *theimage;
  int type;
  strncpy(sstr,name,15);
  sstr[15] = 0;
 
  theimage = DateiImage;
  fcol = 7; bcol = 8;
  switch((type=GetFileType(name))){
    case F_TYPE_O:   theimage = DateiOImage;   bcol=8;  fcol= 7;  break;
    case F_TYPE_BAK: theimage = DateiBAKImage; bcol=8;  fcol=15;  break;
 
    default:
      if ((type >= F_TYPE_STANDARD)&(type < F_TYPE_STANDARD+MAX_FILETYPES)){
        if (IconImage[type-F_TYPE_STANDARD] != NULL){
          theimage = IconImage[type-F_TYPE_STANDARD];
          fcol=SETUP.StandardBCol[type-F_TYPE_STANDARD];
          bcol=SETUP.StandardFCol[type-F_TYPE_STANDARD];  break;
          };
        };
 
    };
 
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[bcol] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[fcol] );
  /*}}}  */
 
  if (IsLink(SETUP.cur_dir,name)){
    /*{{{  XPutImage(*/
    if (SETUP.draw_icon){
      XPutImage(
        XbWVSy_ConTxt.dpy,
        XbWVSy_ConTxt.window,
        XbWVSy_ConTxt.gc,
        LinkImage,
        0,0,
        ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
        icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
        ICON_SIZE_X,
        ICON_SIZE_Y
        );
      };
    /*}}}  */
    };
  /*{{{  XPutImage(*/
  if (SETUP.draw_icon){
    XPutImage(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      theimage,
      0,0,
      ICON_FSTART_X+icon_x*ICON_SPACE_X+27,
      icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
      ICON_SIZE_X,
      ICON_SIZE_Y
      );
    };
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  XbWSGr_BCBox(
    ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-15,
    ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X-2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-2,
    sname,
    bcol,
    fcol,
    fcol);
  /*}}}  */
 
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[bcol] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[fcol] );
  /*}}}  */
  /*{{{  XPutImage(*/
  if (SETUP.draw_icon){
    XPutImage(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      theimage,
      0,0,
      ICON_FSTART_X+icon_x*ICON_SPACE_X+27,
      icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
      ICON_SIZE_X,
      ICON_SIZE_Y
      );
    };
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  XbWSGr_BCBox(
    ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-15,
    ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X-2,
    icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-2,
    sname,15,8,15);
  /*}}}  */
  XFlush(XbWVSy_ConTxt.dpy);
 
  };
/*}}}  */
/*{{{  void ConfigureStandardType(char *fname, int typeno, int xa, int ya){*/
void ConfigureStandardType(char *fname, int typeno, int xa, int ya){
  char sstr[200], qstr[200];;
 
  switch (GetUserAnswer(xa, ya, "Load setup file for this", "directory?",
     " Global", " Local", " Cancel")){
    case 2: LoadSetup("Xdesktop.res");   break;
    case 1: LoadSetup("//Xdesktop.res"); break;
    };
 
  sprintf(sstr," like %s",fname);
  sprintf(qstr,"%s",SETUP.StandardLabel[typeno]);
  if (GetUserRequest(xa, ya, " Modify search pattern for files",sstr,qstr)) {
    strcpy(SETUP.StandardLabel[typeno],qstr);
    };
  sprintf(qstr,"%s",SETUP.StandardAction[typeno]);
  if (GetUserRequest(xa, ya, " Modify comand line for files",sstr,qstr)) {
    strcpy(SETUP.StandardAction[typeno],qstr);
    };
  sprintf(qstr,"%s",SETUP.StandardIcon[typeno]);
  if (GetUserRequest(xa, ya, " Modify icon name for files",sstr,qstr)) {
    strcpy(SETUP.StandardIcon[typeno],qstr);
    };
  sprintf(qstr,"%d",SETUP.StandardFCol[typeno]);
  if (GetUserRequest(xa, ya, " Modify foreground color for files",sstr,qstr)) {
    SETUP.StandardFCol[typeno] = atoi(PackText(qstr));
    };
  sprintf(qstr,"%d",SETUP.StandardBCol[typeno]);
  if (GetUserRequest(xa, ya, " Modify background color for files",sstr,qstr)) {
    SETUP.StandardBCol[typeno] = atoi(PackText(qstr));
    };
  switch (GetUserAnswer(xa, ya, " Do you like to save the actual setup", "",
    " Global", " Local", " Cancel")){
    case 2: SaveSetup("Xdesktop.res"); break;
    case 1: SaveSetup("//Xdesktop.res"); break;
    };
  MarkDirectoryDisplay(0,1);
  };
/*}}}  */
/*{{{  void ConfigureFileType(char *fname, int typeno, int xa, int ya){*/
void ConfigureFileType(char *fname, int typeno, int xa, int ya){
  char sstr[200], qstr[200];;
 
  switch (GetUserAnswer(xa, ya, "Load setup file for this", "directory?",
     " Global", " Local", " Cancel")){
    case 2: LoadSetup("Xdesktop.res");   break;
    case 1: LoadSetup("//Xdesktop.res"); break;
    };
 
  sprintf(sstr," entry \"%s\" for files like %s:",SETUP.FileMenuLabel[typeno],fname);
  sprintf(qstr,"%s",SETUP.FileMenuLabel[typeno]);
  if (GetUserRequest(xa, ya, " Modify text for file menu",sstr,qstr)) {
    strcpy(SETUP.FileMenuLabel[typeno],qstr);
    };
  sprintf(qstr,"%s",SETUP.FileMenuAction[typeno]);
  if (GetUserRequest(xa, ya, " Modify comand line for file menu",sstr,qstr)) {
    strcpy(SETUP.FileMenuAction[typeno],qstr);
    };
  switch (GetUserAnswer(xa, ya, " Do you like to save the actual setup", "",
    " Global", " Local", " Cancel")){
    case 2: SaveSetup("Xdesktop.res"); break;
    case 1: SaveSetup("//Xdesktop.res"); break;
    };
  MarkDirectoryDisplay(0,1);
  };
/*}}}  */
/*{{{  void ConfigureDirType(char *fname, int typeno, int xa, int ya){*/
void ConfigureDirType(char *fname, int typeno, int xa, int ya){
  char sstr[200], qstr[200];;
 
  switch (GetUserAnswer(xa, ya, "Load setup file for this", "directory?",
     " Global", " Local", " Cancel")){
    case 2: LoadSetup("Xdesktop.res");   break;
    case 1: LoadSetup("//Xdesktop.res"); break;
    };
 
  sprintf(sstr," entry \"%s\":",SETUP.DirMenuLabel[typeno]);
  sprintf(qstr,"%s",SETUP.DirMenuLabel[typeno]);
  if (GetUserRequest(xa, ya, " Modify text for directory menu",sstr,qstr)) {
    strcpy(SETUP.DirMenuLabel[typeno],qstr);
    };
  sprintf(qstr,"%s",SETUP.DirMenuAction[typeno]);
  if (GetUserRequest(xa, ya, " Modify comand line for directory menu",sstr,qstr)) {
    strcpy(SETUP.DirMenuAction[typeno],qstr);
    };
  switch (GetUserAnswer(xa, ya, " Do you like to save the actual setup", "",
    " Global", " Local", " Cancel")){
    case 2: SaveSetup("Xdesktop.res"); break;
    case 1: SaveSetup("//Xdesktop.res"); break;
    };
  MarkDirectoryDisplay(0,1);
  };
/*}}}  */
/*{{{  int ClickFileIcon(char *name, char *sname, int xa, int ya){*/
int ClickFileIcon(char *name, char *sname, int xa, int ya){
  char comstr[400];
  int type;
 
  ShowClickedFileIcon(name,sname);
 
  switch(type=GetFileType(sname)){
    case F_TYPE_UNKNOWN:
      ShowFile(name);
      return(1);
    case F_TYPE_O:
      if (!SETUP.ASK_BEFORE_DELETE){
        sprintf(comstr,"rm %s ",name); system(comstr);
        };
      break;
    case F_TYPE_BAK:
      if (!SETUP.ASK_BEFORE_DELETE){
        sprintf(comstr,"rm %s ",name); system(comstr);
        };
      break;
    default:
      if ((type >= F_TYPE_STANDARD)&(type < F_TYPE_STANDARD+MAX_FILETYPES)){
        if (!CONFIG_XDESKTOP){
          ExecCommandLine(
            SETUP.StandardAction[type-F_TYPE_STANDARD],
            sname,name,
            xa,ya);
          }
        else {
          ConfigureStandardType(sname,type-F_TYPE_STANDARD,xa,ya);
          };
        break;
        };
    };
  return(0);
  };
/*}}}  */
/*{{{  int ClickDirAction(int xa, int ya){*/
int ClickDirAction(int xa, int ya){
  int ii;
  if (xa+100 >= SETUP.winw){
    xa=SETUP.winw-100;
    };
  if (ya+MenuSumY*MenuDY >= SETUP.winh){
    ya=SETUP.winh-MenuSumY*MenuDY;
    };
  XbWSMs_SetArrowCursor();
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[15] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[8] );
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
  for (ii=0;ii<MenuSumY;ii++){
    XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
    SETUP.DirMenuLabel[ii],15,8,8);
    };
  /*}}}  */
  /*{{{  Event-Loop*/
      { XEvent event;
        for ( ; ; ) {
          while (!XCheckMaskEvent(
            XbWVSy_ConTxt.dpy,
            KeyPressMask|
            ButtonPressMask|
            ExposureMask,
            &event)) {
            if (ShowDirectory()){
              XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
              for (ii=0;ii<MenuSumY;ii++){
                XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
                SETUP.DirMenuLabel[ii],15,8,8);
                };
              };
            };
          switch(event.type){
            case Expose:
            case EnterNotify:
              MarkDirectoryDisplay(0,1);
              XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
              for (ii=0;ii<MenuSumY;ii++){
                XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
                SETUP.DirMenuLabel[ii],15,8,8);
                };
              break;
            case MotionNotify:
              break;
            case KeyPress:
              {
                KeySym keysym;
                char *keysymname;
                int n;
                char string[257];
                XKeyEvent *keyevent;
                keyevent = (XKeyEvent *)&event;
                n = XLookupString(keyevent, string, 256, &keysym, NULL);
  
                strncpy( XbWVSy_ConTxt.key,string,255);
                XbWVSy_ConTxt.key[255] = 0;
  
                XbWSMs_SetClockCursor();
                return -1;
                break;
                };
            case ButtonPress:
              { int rootx,rooty,winx,winy,mask;
                Window root, child;
                if ( XQueryPointer(
                       XbWVSy_ConTxt.dpy,
                       XbWVSy_ConTxt.window,
                       &root, &child,
                       &rootx, &rooty,
                       &winx, &winy,
                       &mask
                       )
                     ){
                  XbWVMs_XPos = winx;
                  XbWVMs_YPos = winy;
                  if (mask & Button1Mask){
                    if (winx >= xa){
                      if (winx <= xa +100){
                        if (winy >= ya){
                          if (winy <= ya+MenuSumY*MenuDY){
                            return((winy - ya)/MenuDY);
                            XbWSMs_SetClockCursor();
                            };
                          };
                        };
                      };
                    }
                  else {
                    if (mask & Button3Mask){
                      };
                    };
                  break;
                  };
                };
              break;
  
            };
          };
        };
  /*}}}  */
  XbWSMs_SetClockCursor();
  return(-1);
  };
/*}}}  */
/*{{{  int ClickFileAction(int xa, int ya, char *name, char *sname){*/
int ClickFileAction(int xa, int ya, char *name, char *sname){
  int ii;
  XbWSMs_SetArrowCursor();
  ShowClickedFileIcon(name,sname);
 
  if (xa+100 >= SETUP.winw){
    xa=SETUP.winw-100;
    };
  if (ya+MenuSumY*MenuDY >= SETUP.winh){
    ya=SETUP.winh-MenuSumY*MenuDY;
    };
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[15] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[8] );
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
  XbWSGr_TLBox(xa,ya,xa+100,ya+MenuDY,
    SETUP.FileMenuLabel[0],1,15,15);
  for (ii=1;ii<MenuSumY;ii++){
    XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
    SETUP.FileMenuLabel[ii],15,8,8);
    };
  /*}}}  */
  /*{{{  Event-Loop*/
      { XEvent event;
        for ( ; ; ) {
          while (!XCheckMaskEvent(
            XbWVSy_ConTxt.dpy,
            KeyPressMask|
            ButtonPressMask|
            ExposureMask,
            &event)) {
            if (ShowDirectory()){
              XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
              XbWSGr_TLBox(xa,ya,xa+100,ya+MenuDY,
                SETUP.FileMenuLabel[0],1,15,15);
              for (ii=1;ii<MenuSumY;ii++){
                XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
                  SETUP.FileMenuLabel[ii],15,8,8);
                };
              };
            };
          switch(event.type){
            case Expose:
            case EnterNotify:
              MarkDirectoryDisplay(0,1);
              XbWSGr_TLBox(xa-2,ya-2    ,xa+100+2,ya+ (MenuSumY)*MenuDY+2,"",15,8,8);
              XbWSGr_TLBox(xa,ya,xa+100,ya+MenuDY,
                SETUP.FileMenuLabel[0],1,15,15);
              for (ii=1;ii<MenuSumY;ii++){
                XbWSGr_TLBox(xa,ya+ii*MenuDY,xa+100,ya+(ii+1)*MenuDY,
                  SETUP.FileMenuLabel[ii],15,8,8);
                };
              break;
            case MotionNotify:
              break;
            case KeyPress:
              {
                KeySym keysym;
                char *keysymname;
                int n;
                char string[257];
                XKeyEvent *keyevent;
                keyevent = (XKeyEvent *)&event;
                n = XLookupString(keyevent, string, 256, &keysym, NULL);
  
                strncpy( XbWVSy_ConTxt.key,string,255);
                XbWVSy_ConTxt.key[255] = 0;
  
                XbWSMs_SetClockCursor();
                return -1;
                break;
                };
            case ButtonPress:
              { int rootx,rooty,winx,winy,mask;
                Window root, child;
                if ( XQueryPointer(
                       XbWVSy_ConTxt.dpy,
                       XbWVSy_ConTxt.window,
                       &root, &child,
                       &rootx, &rooty,
                       &winx, &winy,
                       &mask
                       )
                     ){
                  XbWVMs_XPos = winx;
                  XbWVMs_YPos = winy;
                  if (mask & Button1Mask){
                    if (winx >= xa){
                      if (winx <= xa +100){
                        if (winy >= ya){
                          if (winy <= ya+MenuSumY*MenuDY){
                            XbWSMs_SetClockCursor();
                            return((winy - ya)/MenuDY);
                            };
                          };
                        };
                      };
                    }
                  else {
                    if (mask & Button3Mask){
                      };
                    };
                  break;
                  };
                };
              break;
  
            };
          };
        };
  /*}}}  */
  XbWSMs_SetClockCursor();
  return(-1);
  };
/*}}}  */
/*{{{  int StarteAktion(int mausx, int mausy){*/
int StarteAktion(int mausx, int mausy){
  int ii,akt_nr;
  char sstr[200];
  char sdir[200];
 
  icon_f_offset_y = 0;
  icon_x = 0;
  icon_y = 1;
 
  get_directory(SETUP.cur_dir);
 
  XbWSMs_SetClockCursor();
  if (MakeFileList(SETUP.cur_dir, SETUP.dirmask, &dir_list, &file_list) == 0) {
    printf("No files in directory?");
    };
 
  /*{{{  for (ii=0;ii<99;ii++){*/
  for (ii=0;ii<99;ii++){
    if ((char*)dir_list[ii+icon_d_start] == NULL){
      break;
      };
    strcpy(sstr,dir_list[ii+icon_d_start]);
  
    if (mausx >= ICON_DSTART_X+icon_x*ICON_SPACE_X){
      if (mausy >= ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1){
        if (mausx <= ICON_DSTART_X+(icon_x+1)*ICON_SPACE_X){
          if (mausy <= ICON_DSTART_Y+(icon_y)*ICON_D_SPACE_Y+1){
            /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
            XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
              XbWVGr_ColorValues[7] );
            XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
              XbWVGr_ColorValues[8] );
            XDrawRectangle(
              XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
              XbWVSy_ConTxt.gc,
              ICON_DSTART_X+icon_x*ICON_SPACE_X+2,
              ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1,
              ICON_SPACE_X,
              ICON_D_SPACE_Y);
            XDrawRectangle(
              XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
              XbWVSy_ConTxt.gc,
              ICON_DSTART_X+icon_x*ICON_SPACE_X+2+2,
              ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1+2,
              ICON_SPACE_X-4,
              ICON_D_SPACE_Y-4);
            /*}}}  */
            strcpy(sdir,sstr);
            { int result;
              result = ClickDirAction(mausx,mausy);
              if ((result > 0)&(result < MenuSumY)){
                strcpy(sdir,sstr);
                if (!CONFIG_XDESKTOP){
                  return(ExecCommandLine(
                    SETUP.DirMenuAction[result],
                    sdir,sdir,
                    mausx,mausy));
                  }
                else {
                  ConfigureDirType(sdir,result,mausx,mausy);
                  return(0);
                  };
                }
              else {
                return(0);
                };
              };
            };
          };
        };
      };
  
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
  /*{{{  if (icon_x != 0){*/
  if (icon_x != 0){
    icon_y++;
    icon_x = 0;
    };
  /*}}}  */
  akt_nr = (icon_y-1) * ICON_COUNT_X;
  icon_f_offset_y = ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1;
  icon_y = 1;
  /*{{{  for (ii=0;ii<999-akt_nr;ii++){*/
  for (ii=0;ii<999-akt_nr;ii++){
    if ((char*)file_list[ii+icon_f_start] == NULL){
      break;
      };
    strcpy(sstr,file_list[ii+icon_f_start]);
  
    if (mausx >= ICON_FSTART_X+icon_x*ICON_SPACE_X+2){
      if (mausy >= icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1){
        if (mausx <= ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X+2){
          if (mausy <= icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y+1){
            /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
            XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
              XbWVGr_ColorValues[7] );
            XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
              XbWVGr_ColorValues[8] );
            XDrawRectangle(
              XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
              XbWVSy_ConTxt.gc,
              ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
              icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
              ICON_SPACE_X,
              ICON_F_SPACE_Y);
            XDrawRectangle(
              XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
              XbWVSy_ConTxt.gc,
              ICON_FSTART_X+icon_x*ICON_SPACE_X+2+2,
              icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1+2,
              ICON_SPACE_X-4,
              ICON_F_SPACE_Y-4);
            /*}}}  */
            { int result;
              result = ClickFileAction(mausx,mausy,sdir,sstr);
              if ((result > 0)&(result < MenuSumY)){
                strcpy(sdir,sstr);
                if (!CONFIG_XDESKTOP){
                  return(ExecCommandLine(
                    SETUP.FileMenuAction[result],
                    sdir,sdir,
                    mausx,mausy));
                  }
                else {
                  ConfigureFileType(sdir,result,mausx,mausy);
                  };
                }
              else {
                return(0);
                };
              };
            };
          };
        };
      };
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
 
  XbWSMs_SetArrowCursor();
  };
 
/*}}}  */

void SaveSetup(char *name){
  XbWWriteMFXSETUPA(&SETUP,name,NULL);
  };
void LoadSetup(char *name){
  XbWReadMFXSETUPA(&SETUP,name,NULL);
  };
 
