
/*{{{  Copyleft*/

/*
 *
 *      Created: 2.3.1993
 *      H.Maroske
 *      H"ohenweg 32
 *      7760 Radolfzell
 *
 *      Thanks go to
 *
 *      Win Treese
 *      Cambridge Research Lab
 *      Digital Equipment Corporation
 *      treese@crl.dec.com
 *
 *      $Source: /trx/u2/treese/Src/Xdir.rel/RCS/xdir.c,v $
 *
 *          COPYRIGHT 1990
 *        DIGITAL EQUIPMENT CORPORATION
 *         MAYNARD, MASSACHUSETTS
 *        ALL RIGHTS RESERVED.
 *
 * THE INFORMATION IN THIS SOFTWARE IS SUBJECT TO CHANGE WITHOUT NOTICE AND
 * SHOULD NOT BE CONSTRUED AS A COMMITMENT BY DIGITAL EQUIPMENT CORPORATION.
 * DIGITAL MAKES NO REPRESENTATIONS ABOUT THE SUITABILITY OF THIS SOFTWARE
 * FOR ANY PURPOSE.  IT IS SUPPLIED "AS IS" WITHOUT EXPRESS OR IMPLIED
 * WARRANTY.
 *
 * IF THE SOFTWARE IS MODIFIED IN A MANNER CREATING DERIVATIVE COPYRIGHT
 * RIGHTS, APPROPRIATE LEGENDS MAY BE PLACED ON THE DERIVATIVE WORK IN
 * ADDITION TO THAT SET FORTH ABOVE.
 *
 * Permission to use, copy, modify, and distribute this software and its
 * documentation for any purpose and without fee is hereby granted, provided
 * that the above copyright notice appear in all copies and that both that
 * copyright notice and this permission notice appear in supporting
 * documentation, and that the name of Digital Equipment Corporation not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.
 *
 *      Modified: 4 Dec 91 - Paul King (king@cs.uq.oz.au)
 */

/*}}}  */
/*{{{  Includes*/

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/param.h>
#include <sys/stat.h>
#include <dirent.h>
#include <time.h>
#include "config.h"



#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/cursorfont.h>
/*}}}  */
/*{{{  Globale Variablen*/
 
    int WasAFileShow = 0;
    Font standard_font;
    Font grosser_font;

void MarkDirectoryDisplay(int IsExpose, int DoExpose);

int ICON_SUM   =  1;
int ICON_D_SPACE_Y =  17;
int ICON_F_SPACE_Y =  60;
int ICON_COUNT_X = 1;
 
int DOS_FLOPPY_MOUNTED = 0;
int MINIX_FLOPPY_MOUNTED = 0;
 
 int      file_entry_cnt, dir_entry_cnt;
 char    **file_list, **dir_list;
 char    **filelist, **dirlist;

int icon_d_start=0;
int icon_f_start=0;
int icon_f_offset_y = 0;

XbWDSy_XbWContxt XbWVSy_ConTxt;
 
unsigned long int XbWVGr_ColorValues[64];

int XbWVMs_XPos = 0;
int XbWVMs_YPos = 0;
 
int icon_x = 0;
int icon_y = 1;


/*}}}  */
 
/*{{{F config.h*/
/*:::F config.h*/
/*}}}  */
/*{{{F config.c*/
/*:::F config.c*/
/*}}}  */

/*{{{  int InTheBox(int x,int y,int xa,int ya,int xb,int ya){*/
int InTheBox(int x,int y,int xa,int ya,int xb,int yb){
  if (x >= xa) {
    if (x <= xb){
      if (y >= ya){
        if (y <= yb){
          return(1);
          };
        };
      };
    };
  return(0);
  };
/*}}}  */
/*{{{  Search for Directory- and Filenames    * * * * * * * * * * **/
/*{{{  get_directory(char *direct)*/
get_directory(char *direct){

#if defined(SYSV) || defined(SVR4)
    extern char    *getcwd();

#else
    extern char    *getwd();

#endif

#if defined(SYSV) || defined(SVR4)
    if (getcwd(direct, 1024) == NULL) { /* get current working dir */
        printf("%s", "Can't get current directory");
#else
    if (getwd(direct) == NULL) {/* get current working dir */
        printf("%s", direct);  /* err msg is in directory */
#endif
        *direct = '\0';
        return 0;
    }
    return 1;
}
/*}}}  */
/*{{{  void MakeFullPath(char *root, char *filename, char *pathname){*/
/*{{{  Beschreibung*/
/* Function:    MakeFullPath() creates the full pathname for the given file.
 * Arguments:   filename:       Name of the file in question.
 *              pathname:       Buffer for full name.
 * Returns:     Nothing.
 * Notes:
 */
/*}}}  */
void MakeFullPath(char *root, char *filename, char *pathname){
  strcpy(pathname, root);
  strcat(pathname, "/");
  strcat(pathname, filename);
  }
/*}}}  */
/*{{{  int IsDirectory(char *root, char *path){*/
/*{{{  Beschreibung*/
/* Function:    IsDirectory() tests to see if a pathname is a directory.
 * Arguments:   path:   Pathname of file to test.
 * Returns:     True (1) or False (0).
 * Notes:       False is returned if the directory is not accessible.
 */
/*}}}  */
int IsDirectory(char *root, char *path){
    char            fullpath[MAXPATHLEN];
    struct stat     statbuf;
    if (path == NULL)
        return (0);
    MakeFullPath(root, path, fullpath);
    if (stat(fullpath, &statbuf))       /* some error, report that it is not
                                         * a directory */
        return (0);
    if (statbuf.st_mode & S_IFDIR)
        return (1);
    else
        return (0);
}
/*}}}  */
/*{{{  int IsLink(char *root, char *path){*/
int IsLink(char *root, char *path){
  char            fullpath[MAXPATHLEN];
  struct stat     statbuf;
  if (path == NULL) {return (0);};
  MakeFullPath(root, path, fullpath);
  if (IsDirectory(root,path)){
    return(0);
    }
  else {
    if (lstat(fullpath, &statbuf)){
      return(0);
      };
    if (statbuf.st_mode & S_IFLNK == S_IFLNK){
      return (1);
      }
    else {
      return (0);
      };
    };
  };

/*}}}  */
/*{{{  int IsExecutable(char *root, char *path){*/
int IsExecutable(char *root, char *path){
    char            fullpath[MAXPATHLEN];
    struct stat     statbuf;
    if (path == NULL)
        return (0);
    MakeFullPath(root, path, fullpath);
    if (stat(fullpath, &statbuf))       /* some error, report that it is not
                                         * a directory */
        return (0);
    if (statbuf.st_mode & S_IXUSR)
        return (1);
    else
        return (0);
}
/*}}}  */
/*{{{  static int star(char *string, char *pattern){*/
/* Return nonzero if `string' matches Unix-style wildcard pattern
   `pattern'; zero if not. */
static int star(char *string, char *pattern){
  while (wild_match(string, pattern) == 0)
    if (*++string == '\0')
      return 0;
  return 1;
  }
/*}}}  */
/*{{{  int wild_match(char *string, char *pattern){*/
/*{{{  Beschreibung*/
/* wildmatch.c - Unix-style command line wildcards

   This procedure is in the public domain.

   After that, it is just as if the operating system had expanded the
   arguments, except that they are not sorted.  The program name and all
   arguments that are expanded from wildcards are lowercased.

   Syntax for wildcards:
   *            Matches zero or more of any character (except a '.' at
                the beginning of a name).
   ?            Matches any single character.
   [r3z]        Matches 'r', '3', or 'z'.
   [a-d]        Matches a single character in the range 'a' through 'd'.
   [!a-d]       Matches any single character except a character in the
                range 'a' through 'd'.

   The period between the filename root and its extension need not be
   given explicitly.  Thus, the pattern `a*e' will match 'abacus.exe'
   and 'axyz.e' as well as 'apple'.  Comparisons are not case sensitive.

   The wild_match code was written by Rich Salz, rsalz@bbn.com,
   posted to net.sources in November, 1986.

   The code connecting the two is by Mike Slomin, bellcore!lcuxa!mike2,
   posted to comp.sys.ibm.pc in November, 1988.

   Major performance enhancements and bug fixes, and source cleanup,
   by David MacKenzie, djm@ai.mit.edu. */

/* Shell-style pattern matching for ?, \, [], and * characters.
   I'm putting this replacement in the public domain.

   Written by Rich $alz, mirror!rs, Wed Nov 26 19:03:17 EST 1986. */
/*}}}  */
int wild_match_sub(char *string, char *pattern){
    int             prev;       /* Previous character in character class. */
    int             matched;    /* If 1, character class has been matched. */
    int             reverse;    /* If 1, character class is inverted. */
    for (; *pattern; string++, pattern++)
        switch (*pattern) {
        case '\\':
            /* Literal match with following character; fall through. */
            pattern++;
        default:
            if (*string != *pattern)
                return 0;
            continue;
        case '?':
            /* Match anything. */
            if (*string == '\0')
                return 0;
            continue;
        case '*':
            /* Trailing star matches everything. */
            return *++pattern ? star(string, pattern) : 1;
        case '[':
            /* Check for inverse character class. */
            reverse = pattern[1] == INVERT;
            if (reverse)
                pattern++;
            for (prev = 256, matched = 0; *++pattern && *pattern != ']';
                 prev = *pattern)
                if (*pattern == '-'
                    ? *string <= *++pattern && *string >= prev
                    : *string == *pattern)
                    matched = 1;
            if (matched == reverse)
                return 0;
            continue;
        }
    return *string == '\0';
}

int wild_match(char *string, char *pattern){
  char sstr[200], substr[100];
  int ret;
  strcpy(sstr,PackText(pattern));
  while(strlen(sstr) > 0){
    if (strchr(sstr,' ') != NULL){
      strcpy(substr,sstr);
      strcpy(strchr(substr,' '),"\0");
      ret=wild_match_sub(string, substr);
      if (ret){return(ret);};
      strcpy(sstr,PackText(strchr(sstr,' ')));
      }
    else {
      return(wild_match_sub(string,sstr));
      };
    };
  };
/*}}}  */
/*{{{  SPComp() compares two string pointers for qsort().*/
/* Function:    SPComp() compares two string pointers for qsort().
 * Arguments:   s1, s2: strings to be compared.
 * Returns:     Value of strcmp().
 * Notes:
 */
int SPComp(char **s1, char **s2){
  return (strcmp(*s1, *s2));
  }
/*}}}  */
/*{{{  char *SaveString(char *string){*/
char *SaveString(char *string){
  char           *new;
  new = (char *) malloc(strlen(string) + 1);
  strcpy(new, string);
  return (new);
  }
/*}}}  */
/*{{{  long MakeFileList(*/
long MakeFileList(
    char *dir_name,
    char *mask,
    char ***dir_list,
    char ***file_list){

    DIR            *dirp;
    struct dirent  *dp;
    char          **cur_file, **cur_directory;
    char          **last_file, **last_dir;

    cur_file = filelist;
    cur_directory = dirlist;
    last_file = filelist + file_entry_cnt - 1;
    last_dir = dirlist + dir_entry_cnt - 1;

    dirp = opendir(dir_name);
    if (dirp == NULL) {
        *file_list = filelist;
        *file_list[0]="";
        *dir_list = dirlist;
        *dir_list[0]="..";
        return (0);
    }
    /* process any events to ensure cursor is set to wait_cursor */
    /*
     * don't do this inside the following loop because this procedure could
     * be re-entered if the user presses (e.g.) rescan
     */

    for (dp = readdir(dirp); dp != NULL; dp = readdir(dirp)) {
        /* skip over '.' (current dir) */
        if (!strcmp(dp->d_name, "."))
            continue;

        if (IsDirectory(dir_name, dp->d_name)) {
            *cur_directory++ = SaveString(dp->d_name);
            if (cur_directory == last_dir) {    /* out of space, make more */
                dirlist = (char **) realloc(dirlist,
                                        2 * dir_entry_cnt * sizeof(char *));
                cur_directory = dirlist + dir_entry_cnt - 1;
                dir_entry_cnt = 2 * dir_entry_cnt;
                last_dir = dirlist + dir_entry_cnt - 1;
            }
        } else {
            /* check if matches regular expression */
            if ((mask == NULL) || (*mask == '\0'))
                mask = "*";
            else if (*mask == '\0')
                mask = "*";
            if (wild_match(dp->d_name, mask) == 0)
                continue;       /* no, do next */
            if (SETUP.NoDirt){
              if (GetFileType(dp->d_name) == F_TYPE_O){
                continue;
                };
              };
            if (SETUP.NoUnknown){
              if (GetFileType(dp->d_name) == F_TYPE_UNKNOWN){
                continue;
                };
              };
            if (SETUP.NoBackups){
              if (GetFileType(dp->d_name) == F_TYPE_BAK){
                continue;
                };
              };
            if (mask[0] == '*' && dp->d_name[0] == '.')
                continue;       /* skip files with leading . */
            *cur_file++ = SaveString(dp->d_name);
            if (cur_file == last_file) {        /* out of space, make more */
                filelist = (char **) realloc(filelist,
                                       2 * file_entry_cnt * sizeof(char *));
                cur_file = filelist + file_entry_cnt - 1;
                file_entry_cnt = 2 * file_entry_cnt;
                last_file = filelist + file_entry_cnt - 1;
            }
        }
    }
    *cur_file = NULL;
    *cur_directory = NULL;
    {
      if (cur_file != filelist) {
        qsort(filelist, cur_file - filelist, sizeof(char *), SPComp);
        };
      if (cur_directory != dirlist) {
        qsort(dirlist, cur_directory - dirlist, sizeof(char *), SPComp);
        };
      *file_list = filelist;
      *dir_list = dirlist;
      };
    *file_list = filelist;
    *dir_list = dirlist;
    closedir(dirp);
    return 1;
}

/*}}}  */
/*}}}  */
/*{{{  X11-Subfunctions     * * * * * * * * * * * * * * * * * * * **/
/*{{{  XbWSGr_TLBox(       TC3,GNU,X11    Text-Box, linksbundig, oben*/
void XbWSGr_TLBox(
  int xa,int ya,
  int xb,int yb,
  char *msg,
  int fillcol, int textcol, int framecol){
 
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[fillcol] );
    XFillRectangle(
      XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,xb-xa,yb-ya);
      };
  if (msg!=NULL) {
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[textcol] );
    XDrawString(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window,XbWVSy_ConTxt.gc,
      xa+1+XbWVSy_ConTxt.XA,
      ya+15-2+XbWVSy_ConTxt.YA,
      msg,strlen(msg));
    };
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[framecol] );
    XDrawRectangle(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,
      xb-xa,yb-ya);
    };
  };
/*}}}  */
/*{{{  XbWSGr_TCBox(       TC3,GNU,X11    Text-Box, linksbundig, oben*/
void XbWSGr_TCBox(
  int xa,int ya,
  int xb,int yb,
  char *msg,
  int fillcol, int textcol, int framecol){
 
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[fillcol] );
    XFillRectangle(
      XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,xb-xa,yb-ya);
      };
  if (msg!=NULL) {
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[textcol] );
    XDrawString(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window,XbWVSy_ConTxt.gc,
      (xa+xb)/2-strlen(msg)*4+1+XbWVSy_ConTxt.XA,
      ya+15-2+XbWVSy_ConTxt.YA,
      msg,strlen(msg));
    };
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[framecol] );
    XDrawRectangle(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,
      xb-xa,yb-ya);
    };
  };
/*}}}  */
/*{{{  XbWSGr_BCBox(       TC3,GNU,X11    Text-Box, linksbundig, oben*/
void XbWSGr_BCBox(
  int xa,int ya,
  int xb,int yb,
  char *msg,
  int fillcol, int textcol, int framecol){
 
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[fillcol] );
    XFillRectangle(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,xb-xa,yb-ya);
      };
  if (msg!=NULL) {
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[textcol] );
    XDrawString(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window,XbWVSy_ConTxt.gc,
      xa+1+XbWVSy_ConTxt.XA+(ICON_SPACE_X-strlen(msg)*8)/2,
      ya+15-4+XbWVSy_ConTxt.YA,
      msg,strlen(msg));
    };
  if (xb!=0){
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[framecol] );
    XDrawRectangle(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      xa+XbWVSy_ConTxt.XA,
      ya+XbWVSy_ConTxt.YA,
      xb-xa,yb-ya);
    };
  };
/*}}}  */
/*{{{  XbWSGr_BCImageBox(       TC3,GNU,X11    Text-Box, linksbundig, oben*/
void XbWSGr_BCImageBox(
  int xa,int ya,
  int xb,int yb,
  char *msg,
  int fillcol, int textcol, int framecol){
  int laenge;
 
  if (msg!=NULL) {
    laenge = strlen(msg);
    XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[fillcol] );
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[textcol] );
    XDrawImageString(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window,XbWVSy_ConTxt.gc,
      xa+1+XbWVSy_ConTxt.XA+(ICON_SPACE_X-laenge*8)/2,
      ya+15-4+XbWVSy_ConTxt.YA,
      msg,laenge);
    };
  };
/*}}}  */
/*{{{  XbWSMs_SetClockCursor(  GNU,X11    Maustreiber Handcursor*/
Cursor XbWVMs_PtrPtrClock=0;
void XbWSMs_SetClockCursor(void){
  if(XbWVMs_PtrPtrClock == 0) {
    XbWVMs_PtrPtrClock = XCreateFontCursor(XbWVSy_ConTxt.dpy,XC_watch);
    };
  XDefineCursor(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,XbWVMs_PtrPtrClock);
  };
/*}}}  */
/*{{{  XbWSMs_SetArrowCursor(  GNU,X11    Maustreiber Pfeilcursor*/
Cursor XbWVMs_PtrPtrArrow=0;
void XbWSMs_SetArrowCursor(void){
  if(XbWVMs_PtrPtrArrow == 0) {
    XbWVMs_PtrPtrArrow = XCreateFontCursor(XbWVSy_ConTxt.dpy,XC_left_ptr);
    };
  XDefineCursor(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window,XbWVMs_PtrPtrArrow);
  };
/*}}}  */

/*}}}  */
/*{{{  X11-Window * * * * * * * * * * * * * * * * * * * * * * * * **/
/*{{{  XbWFSy_doXXXXXXXXXX(t--,g--,X11    X11 only*/
/*{{{  XbWFSy_doDefineColor(       X11    Farbe allozieren (X11 only)*/
unsigned long  XbWFSy_doDefineColor(int n){
  XColor exakt_color,screen_color;

  if ((XDefaultVisualOfScreen(XbWVSy_ConTxt.screen))->class == TrueColor
      || (XDefaultVisualOfScreen(XbWVSy_ConTxt.screen))->class == PseudoColor
      || (XDefaultVisualOfScreen(XbWVSy_ConTxt.screen))->class == DirectColor
      ||  (XDefaultVisualOfScreen(XbWVSy_ConTxt.screen))->class == StaticColor){
    if (XAllocNamedColor( XbWVSy_ConTxt.dpy, XDefaultColormapOfScreen(XbWVSy_ConTxt.screen),
        SETUP.XbWVGr_ColorTexte[n-1], &screen_color, &exakt_color)) {
      return screen_color.pixel;
      };
    }
  else {
    switch (n){
      case 1: return(XBlackPixelOfScreen(XbWVSy_ConTxt.screen));
      case 2: return(XWhitePixelOfScreen(XbWVSy_ConTxt.screen));
      case 3: return(XBlackPixelOfScreen(XbWVSy_ConTxt.screen));
      };
    };
  return(0);
  };

/*}}}  */
/*{{{  XbWFSy_doCreateWindow(      X11    Hauptwindow generieren*/
void XbWFSy_doCreateWindow(void){
/*  int windowW = XWidthOfScreen(XbWVSy_ConTxt.screen)-10;  */
/*  int windowH = XHeightOfScreen(XbWVSy_ConTxt.screen)-10; */
  int windowW = SETUP.winw;
  int windowH = SETUP.winh;
  int windowX = 1;
  int windowY = 1;

  XSetWindowAttributes xswa;
 
  xswa.event_mask =   ExposureMask |
                      ButtonPressMask;

  xswa.background_pixel = XbWFSy_doDefineColor(8);
  xswa.backing_store    = WhenMapped;
  xswa.save_under       = 0;
  xswa.cursor           = 5;

  XbWVGr_ColorValues[0]  = XbWFSy_doDefineColor(1);
  XbWVGr_ColorValues[1]  = XbWFSy_doDefineColor(2);
  XbWVGr_ColorValues[2]  = XbWFSy_doDefineColor(3);
  XbWVGr_ColorValues[3]  = XbWFSy_doDefineColor(4);
  XbWVGr_ColorValues[4]  = XbWFSy_doDefineColor(5);
  XbWVGr_ColorValues[5]  = XbWFSy_doDefineColor(6);
  XbWVGr_ColorValues[6]  = XbWFSy_doDefineColor(7);
  XbWVGr_ColorValues[7]  = XbWFSy_doDefineColor(8);
  XbWVGr_ColorValues[8]  = XbWFSy_doDefineColor(9);
  XbWVGr_ColorValues[9]  = XbWFSy_doDefineColor(10);
  XbWVGr_ColorValues[10] = XbWFSy_doDefineColor(11);
  XbWVGr_ColorValues[11] = XbWFSy_doDefineColor(12);
  XbWVGr_ColorValues[12] = XbWFSy_doDefineColor(13);
  XbWVGr_ColorValues[13] = XbWFSy_doDefineColor(14);
  XbWVGr_ColorValues[14] = XbWFSy_doDefineColor(15);
  XbWVGr_ColorValues[15] = XbWFSy_doDefineColor(16);
 
  XbWVGr_ColorValues[16] = XbWFSy_doDefineColor(17);
  XbWVGr_ColorValues[17] = XbWFSy_doDefineColor(18);
  XbWVGr_ColorValues[18] = XbWFSy_doDefineColor(19);
  XbWVGr_ColorValues[19] = XbWFSy_doDefineColor(20);
  XbWVGr_ColorValues[20] = XbWFSy_doDefineColor(21);
  XbWVGr_ColorValues[21] = XbWFSy_doDefineColor(22);
  XbWVGr_ColorValues[22] = XbWFSy_doDefineColor(23);
  XbWVGr_ColorValues[23] = XbWFSy_doDefineColor(24);
  XbWVGr_ColorValues[24] = XbWFSy_doDefineColor(25);
  XbWVGr_ColorValues[25] = XbWFSy_doDefineColor(26);
  XbWVGr_ColorValues[26] = XbWFSy_doDefineColor(27);
  XbWVGr_ColorValues[27] = XbWFSy_doDefineColor(28);
  XbWVGr_ColorValues[28] = XbWFSy_doDefineColor(29);
  XbWVGr_ColorValues[29] = XbWFSy_doDefineColor(30);
  XbWVGr_ColorValues[30] = XbWFSy_doDefineColor(31);
  XbWVGr_ColorValues[31] = XbWFSy_doDefineColor(32);
 
 
  XbWVSy_ConTxt.window =
    XCreateWindow(
      XbWVSy_ConTxt.dpy,
      XRootWindowOfScreen(XbWVSy_ConTxt.screen),
      windowX,
      windowY,
      windowW,
      windowH, 0,
      XDefaultDepthOfScreen(XbWVSy_ConTxt.screen),
      InputOutput,
      XDefaultVisualOfScreen(XbWVSy_ConTxt.screen),
      CWEventMask | CWBackPixel,
      &xswa
      );
  };


/*}}}  */
/*{{{  XbWFSy_doUnmapWindows(      X11    Windowdarstellung ENDE*/
void XbWFSy_doUnmapWindows(void){
  XUnmapWindow(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window);
  XDestroyWindow(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window);
  XCloseDisplay(XbWVSy_ConTxt.dpy);
  };
 


/*}}}  */
/*}}}  */
/*{{{  XbWSSy_ResetWM(     TC3,GNU,X11    HAUPTPROGRAMM DES XBW-SYSTEMS*/
int XbWSSy_ResetWM(int argc, char *argv[]){
  int ii;
 
  XbWVSy_ConTxt.dpy = XOpenDisplay(0);
  if (!XbWVSy_ConTxt.dpy){
    printf("ERROR: Could not open X11 Display!");
    exit(-1);
    };
  XbWVSy_ConTxt.screen = XDefaultScreenOfDisplay(XbWVSy_ConTxt.dpy);
 
  XSynchronize(XbWVSy_ConTxt.dpy, False);

  XbWFSy_doCreateWindow();
  {
    XGCValues xgcv;
    xgcv.foreground = XbWFSy_doDefineColor(3);
    xgcv.background = XbWFSy_doDefineColor(3);

    XbWVSy_ConTxt.gc = XCreateGC(XbWVSy_ConTxt.dpy,
          XbWVSy_ConTxt.window, GCForeground | GCBackground, &xgcv);
    };

  {
    standard_font = XLoadFont(XbWVSy_ConTxt.dpy,
      "-misc-*-*-r-normal-*-13-*-*-*-c-*-iso8859-1"
      );
    XSetFont(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.gc, standard_font);
 
    grosser_font = XLoadFont(XbWVSy_ConTxt.dpy,
      "-sony-*-*-r-normal-*-24-*-*-*-c-*-iso8859-1"
      );
    };

  {
    XSizeHints xsh;
 
    xsh.width =  SETUP.winw;
    xsh.height = SETUP.maxy;
    xsh.flags = PSize;
 
    XSetWMNormalHints(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window, &xsh);
    XStoreName(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window, SETUP.wname);
    XSetIconName(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window, "HKom");
    };
 
  XSelectInput(
    XbWVSy_ConTxt.dpy,
    XbWVSy_ConTxt.window,
      KeyPressMask|
      KeyReleaseMask|
      ButtonPressMask|
      ExposureMask|
      ButtonReleaseMask|
      OwnerGrabButtonMask|
      PointerMotionHintMask|
      PointerMotionMask|
      ButtonMotionMask|
      EnterWindowMask|
      LeaveWindowMask
    );

  XbWVSy_ConTxt.XA = 0;
  XbWVSy_ConTxt.YA = 0;
  XbWVSy_ConTxt.XB = SETUP.winw;
  XbWVSy_ConTxt.YB = SETUP.maxy;

  XMapWindow(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.window);

  };

/*}}}  */
/*}}}  */
/*{{{  Main Functions * * * * * * * * * * * * * * * * * * * * * * **/
 
/*{{{  void CalcSizes(void){*/
void CalcSizes(void){
  if (SETUP.draw_icon){
    ICON_D_SPACE_Y =  17;
    ICON_F_SPACE_Y =  60;
    }
  else {
    ICON_D_SPACE_Y =  17;
    ICON_F_SPACE_Y =  15;
    };
  ICON_COUNT_X = SETUP.winw / 100;
  };
/*}}}  */
/*{{{  void SetSmallWindow(void){*/
void SetSmallWindow(void){
  SETUP.winw = 515;
  SETUP.winh = 480;
  SETUP.maxy = 390;
  SETUP.bigsize = 0;
  CalcSizes();
  };
/*}}}  */
/*{{{  void SetBigWindow(void){*/
void SetBigWindow(void){
  SETUP.winw = 880;
  SETUP.winh = 770;
  SETUP.maxy = 640;
  SETUP.bigsize = 1;
  CalcSizes();
  };
/*}}}  */
/*{{{  void SetActWindow(void){*/
void SetActWindow(void){
  XWindowAttributes atts;
  if (XGetWindowAttributes(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      &atts)){
    SETUP.winw = atts.width;
    SETUP.winh = atts.height;
    SETUP.maxy = atts.height-90;
    if (SETUP.maxy < 40){
      SETUP.maxy = SETUP.winh;
      };
    };
  CalcSizes();
  };
/*}}}  */
/*{{{  void ShowNoFileIcon(void){*/
void ShowNoFileIcon(void){
  int fcol,bcol;
  bcol = 7; fcol = 7;
  if (SETUP.draw_icon){
    /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
    XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[bcol] );
    XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
      XbWVGr_ColorValues[fcol] );
    /*}}}  */
    /*{{{  XbWSGr_BCBox(*/
    XbWSGr_BCBox(
      ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
      icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1,
      ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X-2,
      icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-2,
      "",
      bcol,
      fcol,
      fcol);
    /*}}}  */
    };
  };
/*}}}  */
/*{{{  int ShowFile(char *name){*/
void ShowFile(char *name){
  char *msg1 = "";
  char *msg2 = "Please press any key to obtain original directory display.";
  char *msg3 = "";
  char *msg4 = "";
  char *msg5 = "";
 
  int ii,akt_nr;
  char sstr[200];
  char sstr2[200];
  FILE *fp;
  if ((fp = fopen(name,"rt")) == NULL){
    return;
    };
  WasAFileShow = 1;
  ii = 0;
  while ( (!feof(fp)) & ((ii+1)*15 < SETUP.maxy-icon_f_offset_y-ICON_FSTART_Y) ){
    fgets(sstr2,200,fp);
    sstr2[199] = 0;
    if (strchr(sstr2,10) != NULL){
      strcpy(strchr(sstr2,10),"\0");
      };
    if (strchr(sstr2,13) != NULL){
      strcpy(strchr(sstr2,13),"\0");
      };
    XbWSGr_TLBox(
      0,
      icon_f_offset_y+ICON_FSTART_Y+ii*15,
      SETUP.winw,
      icon_f_offset_y+ICON_FSTART_Y+(ii+1)*15,
      sstr2,15,8,7);
    ii++;
    };
 
  /*{{{  XbWSGr_TLBox(*/
  XbWSGr_TLBox(
    0,SETUP.maxy+2,
    SETUP.winw,
    SETUP.maxy+15+2,
    msg1,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+15+2,
    SETUP.winw,
    SETUP.maxy+30+2,
    msg2,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+30+2,
    SETUP.winw,
    SETUP.maxy+45+2,
    msg3,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+45+2,
    SETUP.winw,
    SETUP.maxy+60+2,
    msg4,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+60+2,
    SETUP.winw,
    SETUP.maxy+75+2,
    msg5,7,8,7);
  /*}}}  */
 
 
  fclose(fp);
  };
 
/*}}}  */
/*{{{  int ShowMessages(){*/
void ShowMessages(){
  int ii,akt_nr;
  char sstr[200];
  char sstr2[200];
  char *msg[5][200];
  FILE *fp;
  char *Message1,*Message2,*Message3,*Message4,*Message5;
  if ((fp = fopen("/.xdesktop-buf","rt")) == NULL){
    /*{{{  XbWSGr_TLBox(*/
    XbWSGr_TLBox(
      0,SETUP.maxy+2,
      SETUP.winw,
      SETUP.maxy+15+2,
      SETUP.ShowMSG1,7,8,7);
    XbWSGr_TLBox(
      0,SETUP.maxy+15+2,
      SETUP.winw,
      SETUP.maxy+30+2,
      SETUP.ShowMSG2,7,8,7);
    XbWSGr_TLBox(
      0,SETUP.maxy+30+2,
      SETUP.winw,
      SETUP.maxy+45+2,
      SETUP.ShowMSG3,7,8,7);
    XbWSGr_TLBox(
      0,SETUP.maxy+45+2,
      SETUP.winw,
      SETUP.maxy+60+2,
      SETUP.ShowMSG4,7,8,7);
    XbWSGr_TLBox(
      0,SETUP.maxy+60+2,
      SETUP.winw,
      SETUP.maxy+75+2,
      SETUP.ShowMSG5,7,8,7);
    /*}}}  */
    return;
    };
  strcpy(msg[0],"");
  strcpy(msg[1],"");
  strcpy(msg[2],"");
  strcpy(msg[3],"");
  strcpy(msg[4],"");
  Message1 = &msg[0][0];
  Message2 = &msg[1][0];
  Message3 = &msg[2][0];
  Message4 = &msg[3][0];
  Message5 = &msg[4][0];
 
  while (!feof(fp)){
    { char *tt;
      tt = Message1;
      Message1 = Message2;
      Message2 = Message3;
      Message3 = Message4;
      Message4 = Message5;
      Message5 = tt;
      };
    fgets(Message5,200,fp);
    Message5[199] = 0;
    if (strchr(Message5,10) != NULL){
      strcpy(strchr(Message5,10),"\0");
      };
    if (strchr(Message5,13) != NULL){
      strcpy(strchr(Message5,13),"\0");
      };
    };
  icon_x = 0;
  icon_y = 1;
 
  icon_d_start=0;
  icon_f_start=0;
  icon_f_offset_y = 0;
 
  get_directory(SETUP.cur_dir);
 
  /*{{{  XbWSGr_TLBox(*/
  XbWSGr_TLBox(
    0,SETUP.maxy+2,
    SETUP.winw,
    SETUP.maxy+15+2,
    Message1,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+15+2,
    SETUP.winw,
    SETUP.maxy+30+2,
    Message2,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+30+2,
    SETUP.winw,
    SETUP.maxy+45+2,
    Message3,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+45+2,
    SETUP.winw,
    SETUP.maxy+60+2,
    Message4,7,8,7);
  XbWSGr_TLBox(
    0,SETUP.maxy+60+2,
    SETUP.winw,
    SETUP.maxy+75+2,
    Message5,7,8,7);
  /*}}}  */
 
  fclose(fp);
  unlink("/.xdesktop-buf");
  };
 
/*}}}  */
/*{{{  int GetUserAnswer(int xa, int ya, char *stra, char *strb,*/
int GetUserAnswer(int xa, int ya, char *stra, char *strb,
    char *msg1, char *msg2, char *msg3){
  int ii;
  if (xa >= SETUP.winw - 300 - 5) { xa = SETUP.winw - 300 - 5; };
  if (ya >= SETUP.maxy -  55 - 5) { ya = SETUP.maxy - 55  - 5; };
  if (xa < 0){ return(0); };
  if (ya < 0){ return(0); };
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[15] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[8] );
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  XbWSGr_TLBox(xa-4,ya-4    ,xa+300+4,ya+ 55 +4,""   ,7 ,8 ,8);
  XbWSGr_TLBox(xa-2,ya-2    ,xa+300+2,ya+ 55 +2,""   ,7 ,8 ,8);
  XbWSGr_TLBox(xa  ,ya      ,xa+300  ,ya+ 15   ,stra ,7 ,8 ,7);
  XbWSGr_TLBox(xa  ,ya+15   ,xa+300  ,ya+ 30   ,strb ,7 ,8 ,7);
  XbWSGr_TCBox(xa+2    ,ya+40   ,xa+ 98  ,ya+ 55   ,msg1 ,15,8 ,8);
  XbWSGr_TCBox(xa+2+100,ya+40   ,xa+198  ,ya+ 55   ,msg2 ,15,8 ,8);
  XbWSGr_TCBox(xa+2+200,ya+40   ,xa+298  ,ya+ 55   ,msg3 ,15,8 ,8);
  /*}}}  */
  XbWSMs_SetArrowCursor();
  /*{{{  Event-Loop*/
  { XEvent event;
    for ( ; ; ) {
          while (!XCheckMaskEvent(
            XbWVSy_ConTxt.dpy,
            KeyPressMask|
            ButtonPressMask|
            ExposureMask,
            &event)) {
            if (ShowDirectory()){
              /*{{{  XbWSGr_BCBox(*/
              XbWSGr_TLBox(xa-4,ya-4    ,xa+300+4,ya+ 55 +4,""   ,7 ,8 ,8);
              XbWSGr_TLBox(xa-2,ya-2    ,xa+300+2,ya+ 55 +2,""   ,7 ,8 ,8);
              XbWSGr_TLBox(xa  ,ya      ,xa+300  ,ya+ 15   ,stra ,7 ,8 ,7);
              XbWSGr_TLBox(xa  ,ya+15   ,xa+300  ,ya+ 30   ,strb ,7 ,8 ,7);
              XbWSGr_TCBox(xa+2    ,ya+40   ,xa+ 98  ,ya+ 55   ,msg1 ,15,8 ,8);
              XbWSGr_TCBox(xa+2+100,ya+40   ,xa+198  ,ya+ 55   ,msg2 ,15,8 ,8);
              XbWSGr_TCBox(xa+2+200,ya+40   ,xa+298  ,ya+ 55   ,msg3 ,15,8 ,8);
              /*}}}  */
              };
            };
      switch(event.type){
        case Expose:
        case EnterNotify:
          MarkDirectoryDisplay(1,0);
          break;
        case MotionNotify:
          break;
        case KeyPress:
          {
            KeySym keysym;
            char *keysymname;
            int n;
            char string[257];
            XKeyEvent *keyevent;
            keyevent = (XKeyEvent *)&event;
            strcpy(string,"");
            n = XLookupString(keyevent, string, 256, &keysym, NULL);
  
            strncpy( XbWVSy_ConTxt.key,string,255);
            XbWVSy_ConTxt.key[255] = 0;
  
            if ( (string[0] | 0x20) == (msg1[0] | 0x20) ){ return(1); };
            if ( (string[0] | 0x20) == (msg2[0] | 0x20) ){ return(2); };
            if ( (string[0] | 0x20) == (msg3[0] | 0x20) ){ return(3); };
            switch(string[0]){
              case 13: return(1);
              case 27: return(0);;
              };
            break;
            };
        case ButtonPress:
          { int rootx,rooty,winx,winy,mask;
            Window root, child;
            if ( XQueryPointer(
                   XbWVSy_ConTxt.dpy,
                   XbWVSy_ConTxt.window,
                   &root, &child,
                   &rootx, &rooty,
                   &winx, &winy,
                   &mask
                   )
                 ){
              if ( InTheBox(winx, winy, xa+2    ,ya+40   ,xa+ 98  ,ya+ 55)){
                return(1);
                };
              if ( InTheBox(winx, winy, xa+2+100,ya+40   ,xa+198  ,ya+ 55)){
                return(2);
                };
              if ( InTheBox(winx, winy, xa+2+200,ya+40   ,xa+298  ,ya+ 55)){
                return(3);
                };
              };
            };
          break;
  
        };
      };
    };
  /*}}}  */
  return(0);
  };
/*}}}  */
/*{{{  int GetUserRequest(int xa, int ya, char *stra, char *strb, char *req){*/
int GetUserRequest(int xxa, int yya, char *stra, char *strb, char *req){
  int ii;
  static char ureq[200];
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[15] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[8] );
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  strcpy(ureq,req);
  XbWSGr_TLBox(10-4,10-4    ,10+(SETUP.winw-10)+4,10+ 55 +4,""   ,7 ,8 ,8);
  XbWSGr_TLBox(10-2,10-2    ,10+(SETUP.winw-10)+2,10+ 55 +2,""   ,7 ,8 ,8);
  XbWSGr_TLBox(10  ,10      ,10+(SETUP.winw-10)  ,10+ 15   ,stra ,7 ,8 ,7);
  XbWSGr_TLBox(10  ,10+15   ,10+(SETUP.winw-10)  ,10+ 30   ,strb ,7 ,8 ,7);
  XbWSGr_TLBox(10  ,10+40   ,10+(SETUP.winw-10)  ,10+ 55   ,ureq ,15,8 ,8);
  /*}}}  */
  XbWSMs_SetArrowCursor();
  /*{{{  Event-Loop*/
  { XEvent event;
    for ( ; ; ) {
          while (!XCheckMaskEvent(
            XbWVSy_ConTxt.dpy,
            KeyPressMask|
            ButtonPressMask|
            ExposureMask,
            &event)) {
            if (ShowDirectory()){
              XbWSGr_TLBox(10  ,10+40   ,10+(SETUP.winw-10)  ,10+ 55   ,ureq ,15,8,8);
              };
            };
      switch(event.type){
        case Expose:
        case EnterNotify:
          MarkDirectoryDisplay(1,0);
          break;
        case MotionNotify:
          break;
        case KeyPress:
          {
            KeySym keysym;
            char *keysymname;
            int n;
            char string[257];
            XKeyEvent *keyevent;
            keyevent = (XKeyEvent *)&event;
            strcpy(string,"");
            n = XLookupString(keyevent, string, 256, &keysym, NULL);
  
            strncpy( XbWVSy_ConTxt.key,string,255);
            XbWVSy_ConTxt.key[255] = 0;
  
            switch(string[0]){
              case 13: goto endinput;
              case 27: goto abbruch;
              case 8:  ureq[strlen(ureq)-1] = 0; break;
              default:
                string[1] = 0;
                strcat(ureq,string);
                break;
              };
            XbWSGr_TLBox(10  ,10+40   ,10+(SETUP.winw-10)  ,10+ 55   ,ureq ,15,8,8);
            break;
            };
        case ButtonPress:
          { int rootx,rooty,winx,winy,mask;
            Window root, child;
            if ( XQueryPointer(
                   XbWVSy_ConTxt.dpy,
                   XbWVSy_ConTxt.window,
                   &root, &child,
                   &rootx, &rooty,
                   &winx, &winy,
                   &mask
                   )
                 ){
              };
            goto abbruch;
            };
          break;
  
        };
      };
    };
  /*}}}  */
  endinput:
    strcpy(req,ureq);
    return(1);
  abbruch: return(0);
  };
/*}}}  */
/*{{{  int GetBigUserRequest(int xa, int ya, char *stra, char *strb, char *req){*/
int GetBigUserRequest(int xa, int ya, char *stra, char *strb, char *req){
  int ii;
  static char ureq[200];
  if (xa >= SETUP.winw - 600 - 5) { xa = SETUP.winw - 600 - 5; };
  if (ya >= SETUP.maxy -  55 - 5) { ya = SETUP.maxy - 55  - 5; };
  if (xa < 0){ return(0); };
  if (ya < 0){ return(0); };
  /*{{{  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,*/
  XSetBackground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[15] );
  XSetForeground(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.gc,
    XbWVGr_ColorValues[8] );
  /*}}}  */
  /*{{{  XbWSGr_BCBox(*/
  strcpy(ureq,req);
  XbWSGr_TLBox(xa-4,ya-4    ,xa+600+4,ya+ 55 +4,""   ,7 ,8 ,8);
  XbWSGr_TLBox(xa-2,ya-2    ,xa+600+2,ya+ 55 +2,""   ,7 ,8 ,8);
  XbWSGr_TLBox(xa  ,ya      ,xa+600  ,ya+ 15   ,stra ,7 ,8 ,7);
  XbWSGr_TLBox(xa  ,ya+15   ,xa+600  ,ya+ 30   ,strb ,7 ,8 ,7);
  XbWSGr_TLBox(xa  ,ya+40   ,xa+600  ,ya+ 55   ,ureq ,15,8 ,8);
  /*}}}  */
  XbWSMs_SetArrowCursor();
  /*{{{  Event-Loop*/
  { XEvent event;
    for ( ; ; ) {
          while (!XCheckMaskEvent(
            XbWVSy_ConTxt.dpy,
            KeyPressMask|
            ButtonPressMask|
            ExposureMask,
            &event)) {
            if (ShowDirectory()){
              XbWSGr_TLBox(xa  ,ya+40   ,xa+600  ,ya+ 55   ,ureq ,15,8,8);
              };
            };
      switch(event.type){
        case Expose:
        case EnterNotify:
          MarkDirectoryDisplay(1,0);
          break;
        case MotionNotify:
          break;
        case KeyPress:
          {
            KeySym keysym;
            char *keysymname;
            int n;
            char string[257];
            XKeyEvent *keyevent;
            keyevent = (XKeyEvent *)&event;
            strcpy(string,"");
            n = XLookupString(keyevent, string, 256, &keysym, NULL);
  
            strncpy( XbWVSy_ConTxt.key,string,255);
            XbWVSy_ConTxt.key[255] = 0;
  
            switch(string[0]){
              case 13: goto endinput;
              case 27: goto abbruch;
              case 8:  ureq[strlen(ureq)-1] = 0; break;
              default:
                string[1] = 0;
                strcat(ureq,string);
                break;
              };
            XbWSGr_TLBox(xa  ,ya+40   ,xa+600  ,ya+ 55   ,ureq ,15,8,8);
            break;
            };
        case ButtonPress:
          { int rootx,rooty,winx,winy,mask;
            Window root, child;
            if ( XQueryPointer(
                   XbWVSy_ConTxt.dpy,
                   XbWVSy_ConTxt.window,
                   &root, &child,
                   &rootx, &rooty,
                   &winx, &winy,
                   &mask
                   )
                 ){
              };
            goto abbruch;
            };
          break;
  
        };
      };
    };
  /*}}}  */
  endinput:
    strcpy(req,ureq);
    return(1);
  abbruch: return(0);
  };
/*}}}  */
/*{{{  int ShowDirectory(void){*/
char sdir[200];
int ToShow = 0;
int WasAnExpose = 0;
time_t LastShowTime = 0;
int ShowDirectory(void){
  time_t atime;
  int ii,akt_nr;
  char sstr[200];
  char sstr2[200];
 
  if (!ToShow){ return(0); };
  icon_x = 0;
  icon_y = 1;
 
  icon_d_start=0;
  icon_f_start=0;
  icon_f_offset_y = 0;
 
  time(&atime);
  if (atime - LastShowTime < 1){return(0); };
 
  get_directory(SETUP.cur_dir);
 
  SetActWindow();
 
  nice(-20);
  /*{{{  Display*/
  if (WasAFileShow){
    XbWSGr_TLBox(
      0,0,
      SETUP.winw,SETUP.winh,
      "",7,7,7);
    WasAFileShow=0;
    };
  if (!WasAnExpose) {
    XbWSGr_TLBox(
      0,0,
      SETUP.winw,SETUP.winh,
      "",7,7,7);
    }
  else {
    if (atime > LastShowTime+1) {
      XbWSGr_TLBox(
        0,0,
        SETUP.winw,SETUP.winh,
        "",7,7,7);
      };
    };
  LastShowTime=atime;
  /*{{{  XbWSGr_TLBox(*/
  sprintf(sstr2,"=> %s/%s",SETUP.cur_dir,SETUP.dirmask);
  XbWSGr_TLBox(
    10,3,
    490,19,
    sstr2,15,8,8);
  
  XbWSGr_TLBox(
    70,23,
    140,39,
    " cd /root",1,15,15);
  
  XbWSGr_TLBox(
    10,23,
    70,39,
    " xterm",16,8,8);
  
  XbWSGr_TLBox(
    140,23,
    210,39,
    " command",1,15,15);
  if (SETUP.draw_icon){
    XbWSGr_TLBox(
      210,23,
      280,39,
      " no icons",1,15,15);
    }
  else {
    XbWSGr_TLBox(
      210,23,
      280,39,
      " icons",15,1,15);
    };
  XbWSGr_TLBox(
    350,23,
    420,39,
    " task",1,15,15);
  XbWSGr_TLBox(
    420,23,
    490,39,
    " exit",16,8,8);
  
  if (!CONFIG_XDESKTOP){
    XbWSGr_TLBox(
      10,41,
      70,57,
      " Config",1,15,15);
    }
  else {
    XbWSGr_TLBox(
      10,41,
      70,57,
      " CONFIG",3,1,1);
    };
  if (!DOS_FLOPPY_MOUNTED){
    XbWSGr_TLBox(
      70,41,
      140,57,
      " DOS /a/",1,15,15);
    }
  else {
    XbWSGr_TLBox(
      70,41,
      140,57,
      " DOS /a/",14,1,1);
    };
  if (DOS_FLOPPY_MOUNTED||MINIX_FLOPPY_MOUNTED){
    XbWSGr_TLBox(
      140,41,
      210,57,
      " umnt FLO",3,15,15);
    }
  else {
    XbWSGr_TLBox(
      140,41,
      210,57,
      " ",1,15,15);
    };
  if (SETUP.ASK_BEFORE_DELETE){
    XbWSGr_TLBox(
      210,41,
      280,57,
      " Ask:Del?",1,15,15);
    }
  else {
    XbWSGr_TLBox(
      210,41,
      280,57,
      " Delete!",3,15,15);
    };
  
  if (SETUP.NoDirt){
    XbWSGr_TLBox(
      280,41,
      350,57,
      " No Dirt",3,15,15);
    }
  else {
    XbWSGr_TLBox(
      280,41,
      350,57,
      "+Rubbish",1,15,15);
    };
  
  if (SETUP.NoUnknown){
    XbWSGr_TLBox(
      350,41,
      420,57,
      " Known",3,15,15);
    }
  else {
    XbWSGr_TLBox(
      350,41,
      420,57,
      "+Unknown",1,15,15);
    };
  
  if (SETUP.NoBackups){
    XbWSGr_TLBox(
      420,41,
      490,57,
      " No Back",3,15,15);
    }
  else {
    XbWSGr_TLBox(
      420,41,
      490,57,
      "+Backups",1,15,15);
    };
  /*}}}  */
  /*{{{  if (SETUP.bigsize){*/
  if (SETUP.bigsize){
    XbWSGr_TLBox(
      280,23,
      350,39,
      " small",1,15,15);
    }
  else {
    XbWSGr_TLBox(
      280,23,
      350,39,
      " big",1,15,15);
    };
  /*}}}  */
  
  if (MakeFileList(SETUP.cur_dir, SETUP.dirmask, &dir_list, &file_list) == 0)
    printf("No files in directory?");
  
  /*{{{  for (ii=0;ii<99;ii++){*/
  for (ii=0;ii<99;ii++){
    if ((char*)dir_list[ii+icon_d_start] == NULL){
      /*{{{  XbWSGr_BCBox(*/
      XbWSGr_BCBox(
        ICON_DSTART_X+icon_x*ICON_SPACE_X+2,
        ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1,
        ICON_DSTART_X+(icon_x+1)*ICON_SPACE_X-2,
        ICON_DSTART_Y+icon_y*ICON_D_SPACE_Y-1,
        "",7,7,7);
      /*}}}  */
      break;
      };
    strncpy(sstr,dir_list[ii+icon_d_start],15);
    sstr[15] = 0;
  
    if (ii==99-1){ /* more entries... */
      /*{{{  XbWSGr_BCBox(*/
      XbWSGr_BCBox(
        ICON_DSTART_X+icon_x*ICON_SPACE_X+2,
        ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1,
        ICON_DSTART_X+(icon_x+1)*ICON_SPACE_X-2,
        ICON_DSTART_Y+icon_y*ICON_D_SPACE_Y-1,
        "more...",7,8,7);
      /*}}}  */
      break;
      };
  
    /*{{{  XbWSGr_BCImageBox(*/
    XbWSGr_BCImageBox(
      ICON_DSTART_X+icon_x*ICON_SPACE_X+2,
      ICON_DSTART_Y+icon_y*ICON_D_SPACE_Y-13,
      ICON_DSTART_X+(icon_x+1)*ICON_SPACE_X-2,
      ICON_DSTART_Y+icon_y*ICON_D_SPACE_Y,
      sstr,7,8,7);
    /*}}}  */
    if (IsLink(SETUP.cur_dir,dir_list[ii+icon_d_start])){
      /*{{{  XPutImage(*/
      if (SETUP.draw_icon){
        XPutImage(
          XbWVSy_ConTxt.dpy,
          XbWVSy_ConTxt.window,
          XbWVSy_ConTxt.gc,
          LinkImage,
          0,0,
          ICON_DSTART_X+icon_x*ICON_SPACE_X+2,
          ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1,
          ICON_SIZE_X,
          ICON_SIZE_Y
          );
        };
      /*}}}  */
      };
    XDrawRectangle(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      ICON_DSTART_X+icon_x*ICON_SPACE_X+3,
      ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+5,
      ICON_SPACE_X-4,
      ICON_D_SPACE_Y-5
      );
    XDrawRectangle(
      XbWVSy_ConTxt.dpy,
      XbWVSy_ConTxt.window,
      XbWVSy_ConTxt.gc,
      ICON_DSTART_X+icon_x*ICON_SPACE_X+10,
      ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+2,
      8,
      3
      );
  
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
  /*{{{  if (icon_x != 0){*/
  if (icon_x != 0){
    icon_y++;
    icon_x = 0;
    };
  /*}}}  */
  akt_nr = (icon_y-1) * ICON_COUNT_X;
  icon_f_offset_y = ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1;
  icon_y = 1;
  /*{{{  for (ii=0;ii<500;ii++){*/
  for (ii=0;ii<500;ii++){
    if ((char*)file_list[ii+icon_f_start] == NULL){
      ShowNoFileIcon();
      ICON_SUM = ii+akt_nr;
      break;
      };
    strcpy(sdir,SETUP.cur_dir);
    strcat(sdir,"/");
    strcat(sdir,(char*)filelist[ii+icon_f_start]);
  
    if (icon_y > (SETUP.maxy-ICON_F_SPACE_Y-ICON_FSTART_Y-icon_f_offset_y)/ICON_F_SPACE_Y){
        /* last row; more entries? */
      if (icon_x == ICON_COUNT_X-1){
        /*{{{  XbWSGr_BCBox(*/
        XbWSGr_BCBox(
          ICON_FSTART_X+icon_x*ICON_SPACE_X+2,
          icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-15,
          ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X-2,
          icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y-2,
          "more...",7,8,7);
        /*}}}  */
        ICON_SUM = ii+akt_nr;
        break;
        };
      };
  
  
    ShowFileIcon((char*)filelist[ii+icon_f_start],sdir);
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
  
  ShowMessages();
  
  { int ii,jj;
    ii= SETUP.winw-285;
    jj = SETUP.maxy+75+2;
    XSetFont(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.gc, grosser_font);
    XbWSGr_TLBox(
      ii,jj,
      ii+2,jj+2,
      " Hendrikomander 2.2",
      7,
      8,
      7);
    };
  XSetFont(XbWVSy_ConTxt.dpy, XbWVSy_ConTxt.gc, standard_font);
  /*}}}  */
  nice(20);
 
 
  time(&atime);
  LastShowTime=atime;
  ToShow=0;
  WasAnExpose=0;
  XbWSMs_SetArrowCursor();
  return(1);
  };
 
/*}}}  */
/*{{{  void MarkDirectoryDisplay(int IsExpose){*/
void MarkDirectoryDisplay(int IsExpose, int DoExpose){
  time_t atime;
  ToShow = 1;
  time(&atime);
  if (DoExpose){
    LastShowTime=0;
    WasAnExpose = 0;
    XbWSMs_SetClockCursor();
    ShowDirectory();
    XbWSMs_SetArrowCursor();
    }
  else {
    WasAnExpose = IsExpose;
    LastShowTime=atime;
    XbWSMs_SetClockCursor();
    };
  };
 
/*}}}  */
/*{{{  int ClickDirectory(int mausx, int mausy){*/
int ClickDirectory(int mausx, int mausy){
  int ii,akt_nr;
  char sstr[200];
  char sdir[200];
 
  /*{{{  if (mausx >= 10) {*/
  if (mausx >= 10) {
    if (mausy >= 3) {
      if (mausx <= 490) {
        if (mausy <= 19) {
          char tstr[100];
          char dmask[200];
          sprintf(tstr,"(%s):",SETUP.dirmask);
          strcpy(dmask,SETUP.dirmask);
          if (GetUserRequest(mausx,mausy,"Please enter new file display mask",
              tstr,dmask)){
            strcpy(SETUP.dirmask,dmask);
            };
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
 
  /*{{{  if (mausx >= 10) {*/
  if (mausx >= 10) {
    if (mausy >= 23) {
      if (mausx <= 70) {
        if (mausy <= 39) {
          sprintf(sstr,"cd %s; trm &",SETUP.cur_dir);
          system(sstr);
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 70) {*/
  if (mausx >= 70) {
    if (mausy >= 23) {
      if (mausx <= 140) {
        if (mausy <= 39) {
          chdir("/root");
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 140) {*/
  if (mausx >= 140) {
    if (mausy >= 23) {
      if (mausx <= 210) {
        if (mausy <= 39) {
          char cmd[200]="";
          if (SETUP.bigsize){
            if (GetBigUserRequest(mausx,mausy,"Execute your shell command",
              "Enter command here:",cmd)){
              strcat(cmd, " > /.xdesktop-buf ");
              /*{{{  XbWSGr_TLBox(*/
              XbWSGr_TLBox(
                mausx,mausy,
                mausx+200,mausy+60,
                "",15,8,8);
              XbWSGr_TLBox(
                mausx+100-50,mausy+30-7,
                mausx+100+50,mausy+30+8,
                " Please wait",13,15,15);
              /*}}}  */
              XFlush(XbWVSy_ConTxt.dpy);
              system(cmd);
              };
            }
          else {
            if (GetUserRequest(mausx,mausy,"Execute your shell command",
              "Enter command here:",cmd)){
              strcat(cmd, " > /.xdesktop-buf ");
              /*{{{  XbWSGr_TLBox(*/
              XbWSGr_TLBox(
                mausx,mausy,
                mausx+200,mausy+60,
                "",15,8,8);
              XbWSGr_TLBox(
                mausx+100-50,mausy+30-7,
                mausx+100+50,mausy+30+8,
                " Please wait",13,15,15);
              /*}}}  */
              XFlush(XbWVSy_ConTxt.dpy);
              system(cmd);
              };
            };
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 210) {*/
  if (mausx >= 210) {
    if (mausy >= 23) {
      if (mausx <= 280) {
        if (mausy <= 39) {
          SETUP.draw_icon = (~SETUP.draw_icon)&1;
          CalcSizes();
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 280) {*/
  if (mausx >= 280) {
    if (mausy >= 23) {
      if (mausx <= 350) {
        if (mausy <= 39) {
          if (SETUP.bigsize){
            SetSmallWindow();
            }
          else {
            SetBigWindow();
            };
          XbWSMs_SetClockCursor();
          XResizeWindow(
            XbWVSy_ConTxt.dpy,
            XbWVSy_ConTxt.window,
            SETUP.winw,
            SETUP.winh);
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 350) {*/
  if (mausx >= 350) {
    if (mausy >= 23) {
      if (mausx <= 420) {
        if (mausy <= 39) {
          char cmd[200]="";
          if (SETUP.bigsize){
            if (GetBigUserRequest(mausx,mausy,"Start a background task",
              "Enter task command here:",cmd)){
              strcat(cmd, " > /.xdesktop-buf &");
              system(cmd);
              };
            }
          else {
            if (GetUserRequest(mausx,mausy,"Start a background task",
              "Enter task command here:",cmd)){
              strcat(cmd, " > /.xdesktop-buf &");
              system(cmd);
              };
            };
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 420) {*/
  if (mausx >= 420) {
    if (mausy >= 23) {
      if (mausx <= 490) {
        if (mausy <= 39) {
          char cmd[200]="";
          if (GetUserAnswer(mausx,mausy," Quit xdesktop ?","","Yes","No","Cancel") == 1){
            exit(0);
            };
          XbWSMs_SetClockCursor();
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
 
  /*{{{  if (mausx >= 10) {*/
  if (mausx >= 10) {
    if (mausy >= 41) {
      if (mausx <= 70) {
        if (mausy <= 57) {
          if (CONFIG_XDESKTOP){
            CONFIG_XDESKTOP = 0;
            }
          else {
            CONFIG_XDESKTOP = 1;
            };
          if (!CONFIG_XDESKTOP){
            XbWSGr_TLBox(
              10,41,
              70,57,
              " Config",1,15,15);
            }
          else {
            XbWSGr_TLBox(
              10,41,
              70,57,
              " CONFIG",3,1,1);
            };
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 70) {*/
  if (mausx >= 70) {
    if (mausy >= 41) {
      if (mausx <= 140) {
        if (mausy <= 57) {
          XbWSMs_SetClockCursor();
          if (MINIX_FLOPPY_MOUNTED){
            chdir ("/");
            if (system("cd /; umount /dev/fd0") != 0){
              MarkDirectoryDisplay(0,0);
              return;
              };
            };
          if (system("mount /dev/fd0 /a -t msdos") == 0){
            MINIX_FLOPPY_MOUNTED=0;
            DOS_FLOPPY_MOUNTED=1;
            }
          else {
            char lcmd[200]="";
            GetUserRequest(
              mausx,mausy,
              " Could not mount /dev/fd0 -t msdos",
              " Please press <CR>",lcmd);
            };
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 140) {*/
  if (mausx >= 140) {
    if (mausy >= 41) {
      if (mausx <= 210) {
        if (mausy <= 57) {
          char c_dir[200];
          strcpy(c_dir,SETUP.cur_dir);
          XbWSMs_SetClockCursor();
          if (system("umount /dev/fd0") != 0){
            chdir ("/");  /* is it the current directory?? */
            if (system("umount /dev/fd0") == 0){
              MINIX_FLOPPY_MOUNTED = 0;
              DOS_FLOPPY_MOUNTED = 0;
              }
            else {
              char lcmd[200]="";
              GetUserRequest(
                mausx,mausy,
                "Could not umount /dev/fd0",
                "Please press <CR>",lcmd);
              chdir(c_dir); /* get back */
              };
            }
          else {
            MINIX_FLOPPY_MOUNTED = 0;
            DOS_FLOPPY_MOUNTED = 0;
            };
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 210) {*/
  if (mausx >= 210) {
    if (mausy >= 41) {
      if (mausx <= 280) {
        if (mausy <= 57) {
          if (SETUP.ASK_BEFORE_DELETE){
            SETUP.ASK_BEFORE_DELETE = 0;
            }
          else {
            SETUP.ASK_BEFORE_DELETE = 1;
            };
          if (SETUP.ASK_BEFORE_DELETE){
            XbWSGr_TLBox(
              210,41,
              280,57,
              " Ask:Del?",1,15,15);
            }
          else {
            XbWSGr_TLBox(
              210,41,
              280,57,
              " Delete!",3,15,15);
            };
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 280) {*/
  if (mausx >= 280) {
    if (mausy >= 41) {
      if (mausx <= 350) {
        if (mausy <= 57) {
          if (SETUP.NoDirt){
            SETUP.NoDirt = 0;
            }
          else {
            SETUP.NoDirt = 1;
            };
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 350) {*/
  if (mausx >= 350) {
    if (mausy >= 41) {
      if (mausx <= 420) {
        if (mausy <= 57) {
          if (SETUP.NoUnknown){
            SETUP.NoUnknown = 0;
            }
          else {
            SETUP.NoUnknown = 1;
            };
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
  /*{{{  if (mausx >= 420) {*/
  if (mausx >= 420) {
    if (mausy >= 41) {
      if (mausx <= 490) {
        if (mausy <= 57) {
          if (SETUP.NoBackups){
            SETUP.NoBackups = 0;
            }
          else {
            SETUP.NoBackups = 1;
            };
          MarkDirectoryDisplay(0,0);
          return;
          };
        };
      };
    };
  /*}}}  */
 
  icon_f_offset_y = 0;
  icon_x = 0;
  icon_y = 1;
 
  get_directory(SETUP.cur_dir);
 
  if (MakeFileList(SETUP.cur_dir, SETUP.dirmask, &dir_list, &file_list) == 0)
    printf("No files in directory?");
 
  /*{{{  for (ii=0;ii<99;ii++){*/
  for (ii=0;ii<99;ii++){
    if ((char*)dir_list[ii+icon_d_start] == NULL){
      break;
      };
    strcpy(sstr,dir_list[ii+icon_d_start]);
  
    if (mausx >= ICON_DSTART_X+icon_x*ICON_SPACE_X){
      if (mausy >= ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1){
        if (mausx <= ICON_DSTART_X+(icon_x+1)*ICON_SPACE_X){
          if (mausy <= ICON_DSTART_Y+(icon_y)*ICON_D_SPACE_Y+1){
            FILE *fp;
            strcpy(sdir,SETUP.cur_dir);
            strcat(sdir,"/");
            strcat(sdir,sstr);
            chdir(sdir);
            getcwd(sdir);
            /*
            if (strlen(sdir) > 1){
              if ((fp = fopen("Xdesktop.res","rb")) == NULL){
                }
              else {
                fclose(fp);
                switch (GetUserAnswer(mausx, mausy, "Load setup file for this", "directory?",
                   " Global", " Local", " Cancel")){
                  case 2: LoadSetup("Xdesktop.res");   break;
                  case 1: LoadSetup("//Xdesktop.res"); break;
                  };
                };
              };
            */
            MarkDirectoryDisplay(0,1);
            return;
            };
          };
        };
      };
  
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
  /*{{{  if (icon_x != 0){*/
  if (icon_x != 0){
    icon_y++;
    icon_x = 0;
    };
  /*}}}  */
  akt_nr = (icon_y-1) * ICON_COUNT_X;
  icon_f_offset_y = ICON_DSTART_Y+(icon_y-1)*ICON_D_SPACE_Y+1;
  icon_y = 1;
  /*{{{  for (ii=0;ii<ICON_SUM-akt_nr;ii++){*/
  for (ii=0;ii<ICON_SUM-akt_nr;ii++){
    if ((char*)file_list[ii+icon_f_start] == NULL){
      break;
      };
    strcpy(sstr,file_list[ii+icon_f_start]);
  
    if (mausx >= ICON_FSTART_X+icon_x*ICON_SPACE_X+2){
      if (mausy >= icon_f_offset_y+ICON_FSTART_Y+(icon_y-1)*ICON_F_SPACE_Y+1){
        if (mausx <= ICON_FSTART_X+(icon_x+1)*ICON_SPACE_X+2){
          if (mausy <= icon_f_offset_y+ICON_FSTART_Y+icon_y*ICON_F_SPACE_Y+1){
            strcpy(sdir,SETUP.cur_dir);
            strcat(sdir,"/");
            strcat(sdir,sstr);
            XbWSMs_SetClockCursor();
  
            if (strstr(sstr,"Xdesktop.res") != NULL){
              XbWSGr_TLBox(
                 mausx+100-70,mausy+30-15,
                 mausx+100+70,mausy+30+15,
                 " Loading Setup",13,15,15);
              FreeImages();
              LoadSetup(sstr);
              LoadImages();
              if (!CONFIG_XDESKTOP){
                MarkDirectoryDisplay(0,0);
                XbWSMs_SetArrowCursor();
                return;
                };
              };
            if (!ClickFileIcon(sdir,sstr,mausx,mausy)){
              XLowerWindow(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window);
              XbWSMs_SetClockCursor();
              if (CONFIG_XDESKTOP){
                FreeImages();
                LoadImages();
                };
              MarkDirectoryDisplay(0,0);
              return;
              };
            XbWSMs_SetArrowCursor();
            return;
            };
          };
        };
      };
    /*{{{  icon_x +=1;*/
    icon_x +=1;
    if (icon_x >= ICON_COUNT_X){
      icon_x = 0;
      icon_y++;
      };
    /*}}}  */
    };
  /*}}}  */
  XLowerWindow(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window);
 
  };
 
/*}}}  */
/*{{{  int HauptProgramm(int argc, char *argv[]){*/
int HauptProgramm(int argc, char *argv[]){
  XbWSSy_ResetWM(argc,argv);
  LoadImages();
  /*{{{  Event-Loop*/
      { XEvent event;
        for ( ; ; ) {
          if (ToShow){
            while (!XCheckMaskEvent(
                XbWVSy_ConTxt.dpy,
                KeyPressMask|
                ButtonPressMask|
                ExposureMask,
                &event)) {
              if (ShowDirectory()){
                while (XPending(XbWVSy_ConTxt.dpy)){
                  XNextEvent( /* kill old events */
                    XbWVSy_ConTxt.dpy,
                    &event);
                  };
                XNextEvent(   /* get new event */
                  XbWVSy_ConTxt.dpy,
                  &event);
                break;
                };
              };
            }
          else {
            XNextEvent(
              XbWVSy_ConTxt.dpy,
              &event);
            };
  
          switch(event.type){
            case Expose:
            case EnterNotify:
              MarkDirectoryDisplay(1,0);
              break;
            case KeyPress:
              XRaiseWindow(XbWVSy_ConTxt.dpy,XbWVSy_ConTxt.window);
              MarkDirectoryDisplay(0,1);
              break;
            case MotionNotify:
              break;
            case ButtonPress:
              { int rootx,rooty,winx,winy,mask;
                Window root, child;
                if ( XQueryPointer(
                       XbWVSy_ConTxt.dpy,
                       XbWVSy_ConTxt.window,
                       &root, &child,
                       &rootx, &rooty,
                       &winx, &winy,
                       &mask
                       )
                     ){
                  XbWVMs_XPos = winx;
                  XbWVMs_YPos = winy;
                  if (mask & Button1Mask){
                    ClickDirectory(winx,winy);
                    }
                  else {
                    if (mask & Button3Mask){
                      XbWSMs_SetClockCursor();
                      if (!StarteAktion(winx,winy)){
                        MarkDirectoryDisplay(0,0);
                        }
                      else {
                        XbWSMs_SetArrowCursor();
                        };
                      };
                    };
                  break;
                  };
                };
              break;
  
            };
          };
        };
  /*}}}  */
  ende:;
  XbWFSy_doUnmapWindows();
  };
/*}}}  */
/*}}}  */
/*{{{  main(int argc, char *argv[]){*/
main(int argc, char *argv[]){
  FILE *fp;
  if ((fp = fopen("//Xdesktop.res","rb")) != NULL){
    fclose(fp);
    LoadSetup("//Xdesktop.res");
    };
  if (argc > 1){
    if ((fp = fopen(argv[1],"rb")) != NULL){
      fclose(fp);
      LoadSetup(argv[1]);
      };
    }
  else {
    if ((fp = fopen("Xdesktop.res","rb")) != NULL){
      fclose(fp);
      LoadSetup("Xdesktop.res");
      };
    };
  unlink("/.xdesktop-buf");
 
  sprintf(SETUP.cur_dir,"./");
  dir_entry_cnt = SETUP.NENTRIES;
  file_entry_cnt = SETUP.NENTRIES;
  filelist = (char **) calloc(file_entry_cnt, sizeof(char *));
  dirlist = (char **) calloc(dir_entry_cnt, sizeof(char *));
 
  get_directory(SETUP.cur_dir);
 
  if (MakeFileList(SETUP.cur_dir, SETUP.dirmask, &dir_list, &file_list) == 0)
    printf("No files in directory?");

  SetSmallWindow();
 
  ClearImages();
 
  HauptProgramm(argc,argv);
  };
/*}}}  */

